/*     */ package com.netapp.asup.data.function;
/*     */ 
/*     */ import com.netapp.asup.common.AsupLogger;
/*     */ import com.netapp.asup.exception.ARMAFunctionRegistrationException;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import org.apache.avro.Schema;
/*     */ 
/*     */ 
/*     */ 
/*     */ public class FunctionRegistoryObject<I, O>
/*     */   implements RegisteredFunction<I, O>
/*     */ {
/*     */   private String index;
/*  15 */   private static final AsupLogger LOG = AsupLogger.getLogger(FunctionRegistoryObject.class);
/*     */   
/*     */ 
/*     */ 
/*  19 */   private Schema inputSchema = null;
/*  20 */   private Schema outputSchema = null;
/*  21 */   private FunctionInputHandler<I> inputHandler = null;
/*  22 */   private FunctionOutputHandler<O> outputHandler = null;
/*  23 */   private Function function = null;
/*     */   private boolean local;
/*     */   
/*     */   private Function initializeFunction() throws ARMAFunctionRegistrationException {
/*     */     try {
/*  28 */       String className = getAttr(FuncAttributes.FUNCTIONCLASS);
/*  29 */       Class<?> functionClass = Class.forName(className, true, ClassLoader.getSystemClassLoader());
/*     */       
/*  31 */       return (Function)functionClass.newInstance();
/*     */     }
/*     */     catch (ClassNotFoundException e) {
/*  34 */       throw new ARMAFunctionRegistrationException(LOG, "Unable to initialize function :" + toString() + " caused by :" + e.getMessage(), e);
/*     */     } catch (InstantiationException e) {
/*  36 */       throw new ARMAFunctionRegistrationException(LOG, "Unable to initialize function :" + toString() + " caused by :" + e.getMessage(), e);
/*     */     } catch (IllegalAccessException e) {
/*  38 */       throw new ARMAFunctionRegistrationException(LOG, "Unable to initialize function :" + toString() + " caused by :" + e.getMessage(), e);
/*     */     }
/*     */   }
/*     */   
/*     */   public FunctionRegistoryObject(String index)
/*     */   {
/*  44 */     this.index = index;
/*     */   }
/*     */   
/*  47 */   private Map<FuncAttributes, String> props = new HashMap();
/*     */   
/*     */   public void setAttr(FuncAttributes key, String value) {
/*  50 */     this.props.put(key, value);
/*     */   }
/*     */   
/*     */   public String getAttr(FuncAttributes key) {
/*  54 */     return (String)this.props.get(key);
/*     */   }
/*     */   
/*     */   public Map<FuncAttributes, String> getAttrs() {
/*  58 */     return this.props;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getFunctionName()
/*     */   {
/*  66 */     return (String)this.props.get(FuncAttributes.FUNCTIONNAME);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public String toString()
/*     */   {
/*  74 */     StringBuilder str = new StringBuilder("Index:");
/*  75 */     str.append(this.index);
/*  76 */     str.append(",Attributes:");
/*  77 */     str.append(this.props.toString());
/*  78 */     return str.toString();
/*     */   }
/*     */   
/*     */   public void initialize(FunctionRegistry registory) throws ARMAFunctionRegistrationException {
/*  82 */     this.function = initializeFunction();
/*  83 */     this.inputHandler = registory.getInputHandler(getAttr(FuncAttributes.INPUTHANDLERCLASSNAME));
/*  84 */     this.outputHandler = registory.getOutputHandler(getAttr(FuncAttributes.OUTPUTHANDLERCLASSNAME));
/*  85 */     this.inputSchema = registory.getSchema(getAttr(FuncAttributes.INPUTSCHEMAFILE));
/*  86 */     this.outputSchema = registory.getSchema(getAttr(FuncAttributes.OUTPUTSCHEMAFILE));
/*  87 */     this.local = ("LOCAL".equalsIgnoreCase(getAttr(FuncAttributes.FUNCTIONTYPE)));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Schema getOutputSchema()
/*     */   {
/*  95 */     return this.outputSchema;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Schema getInputSchema()
/*     */   {
/* 103 */     return this.inputSchema;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public FunctionInputHandler<I> getInputHandler()
/*     */   {
/* 111 */     return this.inputHandler;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public FunctionOutputHandler<O> getOutputHandler()
/*     */   {
/* 119 */     return this.outputHandler;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Function getFunction()
/*     */   {
/* 127 */     return this.function;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isLocal()
/*     */   {
/* 135 */     return this.local;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\function\FunctionRegistoryObject.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */