/*     */ package com.netapp.asup.filter;
/*     */ 
/*     */ import com.netapp.asup.client.arma.data.ARMAObjectInstance;
/*     */ import com.netapp.asup.exception.ARMAException;
/*     */ import java.util.HashSet;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class FilterUtil
/*     */ {
/*     */   private static final String PATH_DELIMITER = ",";
/*     */   private static final char MULTI_VALUE_CONSTANT = '\037';
/*     */   
/*     */   public static String[] getObjects(Utf8 path)
/*     */   {
/*  21 */     String strPath = path.toString();
/*  22 */     String[] objects = strPath.split(",");
/*  23 */     String[] objectsInLower = new String[objects.length];
/*     */     
/*  25 */     for (int i = 0; i < objects.length; i++) {
/*  26 */       objectsInLower[i] = objects[i].toLowerCase();
/*     */     }
/*  28 */     return objectsInLower;
/*     */   }
/*     */   
/*     */   public static boolean isMatching(ARMAObjectInstance instance, Map<Utf8, Map<Utf8, Utf8>> filters)
/*     */     throws ARMAException
/*     */   {
/*  34 */     boolean isMatching = false;
/*     */     
/*  36 */     Utf8 objectName = new Utf8(instance.getObjectName().toUpperCase());
/*  37 */     Map<Utf8, Utf8> attrMap = (Map)filters.get(objectName);
/*     */     
/*  39 */     if (null == attrMap) {
/*  40 */       return true;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*  45 */     for (Utf8 attrName : attrMap.keySet()) {
/*  46 */       isMatching = false;
/*  47 */       String[] multiValueFilter = handleMultiValueFilter((Utf8)attrMap.get(attrName));
/*  48 */       String recordValue = instance.getAttribute(attrName.toString());
/*     */       
/*  50 */       if (multiValueFilter.length == 1)
/*     */       {
/*     */ 
/*  53 */         if (!multiValueFilter[0].equalsIgnoreCase(recordValue)) {
/*  54 */           return false;
/*     */         }
/*     */       } else {
/*  57 */         for (String currFilterValue : multiValueFilter)
/*     */         {
/*     */ 
/*  60 */           if (currFilterValue.equalsIgnoreCase(recordValue)) {
/*  61 */             isMatching = true;
/*     */             
/*     */ 
/*  64 */             break;
/*     */           }
/*     */         }
/*  67 */         if (!isMatching) {
/*  68 */           return false;
/*     */         }
/*     */       }
/*     */     }
/*  72 */     return true;
/*     */   }
/*     */   
/*     */   private static String[] handleMultiValueFilter(Utf8 filterValue)
/*     */   {
/*  77 */     if (null == filterValue) {
/*  78 */       String[] arrayOfString1 = { null };
/*     */     }
/*  80 */     String[] multiValueFilter = filterValue.toString().split(String.valueOf('\037'));
/*     */     
/*  82 */     return multiValueFilter;
/*     */   }
/*     */   
/*     */ 
/*     */   public static Set<String> addFilterObjects(List<Utf8> objects, Map<Utf8, Map<Utf8, Utf8>> filters)
/*     */   {
/*  88 */     Set<String> objs = new HashSet();
/*  89 */     for (Utf8 object : objects) {
/*  90 */       objs.add(object.toString());
/*     */     }
/*     */     
/*  93 */     for (Utf8 filterObject : filters.keySet()) {
/*  94 */       objs.add(filterObject.toString());
/*     */     }
/*     */     
/*  97 */     return objs;
/*     */   }
/*     */   
/*     */ 
/*     */   public static StringBuilder getFilteredPaths(Utf8 connectedPath, Set<String> objects, Set<String> objectsRequested)
/*     */   {
/* 103 */     StringBuilder filteredPathSB = new StringBuilder();
/* 104 */     String strPath = connectedPath.toString();
/* 105 */     String[] pathObjects = strPath.split(",");
/*     */     
/* 107 */     boolean isValidReqObjPath = false;
/* 108 */     for (String fetchObjects : objectsRequested) {
/* 109 */       isValidReqObjPath = strPath.contains(fetchObjects);
/* 110 */       if (isValidReqObjPath) {
/*     */         break;
/*     */       }
/*     */     }
/*     */     
/* 115 */     if (!isValidReqObjPath) {
/* 116 */       return filteredPathSB;
/*     */     }
/*     */     
/*     */ 
/* 120 */     int startIndex = 0;
/* 121 */     int endIndex = startIndex;
/* 122 */     boolean started = false;
/* 123 */     for (int i = 0; i < pathObjects.length; i++) {
/* 124 */       String pathObject = pathObjects[i];
/*     */       
/* 126 */       if (!started) {
/* 127 */         if (objects.contains(pathObject)) {
/* 128 */           startIndex = i;
/* 129 */           endIndex = i;
/* 130 */           started = true;
/*     */         }
/*     */       }
/* 133 */       else if (objects.contains(pathObject)) {
/* 134 */         endIndex = i;
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 139 */     for (int i = startIndex; i <= endIndex; i++) {
/* 140 */       if (filteredPathSB.length() != 0)
/* 141 */         filteredPathSB.append(",");
/* 142 */       filteredPathSB.append(pathObjects[i]);
/*     */     }
/* 144 */     return filteredPathSB;
/*     */   }
/*     */   
/*     */ 
/*     */   public static Set<Utf8> getDependentObjectsFromPath(Utf8 connectedPath, Set<String> objects, Set<String> objectsRequested)
/*     */   {
/* 150 */     Set<Utf8> depObjects = new HashSet();
/* 151 */     String strPath = connectedPath.toString();
/* 152 */     String[] pathObjects = strPath.split(",");
/*     */     
/*     */ 
/* 155 */     for (int i = 0; i < pathObjects.length; i++) {
/* 156 */       String newObject = pathObjects[i];
/*     */       
/* 158 */       if (!objects.contains(newObject)) {
/* 159 */         depObjects.add(new Utf8(newObject.toUpperCase()));
/*     */       }
/*     */     }
/* 162 */     return depObjects;
/*     */   }
/*     */   
/*     */   public static Set<String> getRequestedObjects(List<Utf8> objects) {
/* 166 */     Set<String> reqObjs = new HashSet();
/* 167 */     for (Utf8 obj : objects) {
/* 168 */       reqObjs.add(obj.toString());
/*     */     }
/* 170 */     return reqObjs;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\filter\FilterUtil.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */