/*     */ package com.sun.xml.bind.v2.bytecode;
/*     */ 
/*     */ import com.sun.xml.bind.Util;
/*     */ import java.io.ByteArrayOutputStream;
/*     */ import java.io.DataInputStream;
/*     */ import java.io.DataOutputStream;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.util.logging.Level;
/*     */ import java.util.logging.Logger;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class ClassTailor
/*     */ {
/*  22 */   private static final Logger logger = Util.getClassLogger();
/*     */   
/*     */ 
/*     */ 
/*     */   public static final String toVMClassName(Class c)
/*     */   {
/*  28 */     assert (!c.isPrimitive());
/*  29 */     if (c.isArray())
/*     */     {
/*  31 */       return toVMTypeName(c); }
/*  32 */     return c.getName().replace('.', '/');
/*     */   }
/*     */   
/*     */   public static final String toVMTypeName(Class c) {
/*  36 */     if (c.isArray())
/*     */     {
/*  38 */       return '[' + toVMTypeName(c.getComponentType());
/*     */     }
/*  40 */     if (c.isPrimitive()) {
/*  41 */       if (c == Boolean.TYPE) return "Z";
/*  42 */       if (c == Character.TYPE) return "C";
/*  43 */       if (c == Byte.TYPE) return "B";
/*  44 */       if (c == Double.TYPE) return "D";
/*  45 */       if (c == Float.TYPE) return "F";
/*  46 */       if (c == Integer.TYPE) return "I";
/*  47 */       if (c == Long.TYPE) return "J";
/*  48 */       if (c == Short.TYPE) { return "S";
/*     */       }
/*  50 */       throw new IllegalArgumentException(c.getName());
/*     */     }
/*  52 */     return 'L' + c.getName().replace('.', '/') + ';';
/*     */   }
/*     */   
/*     */ 
/*     */   public static final byte[] tailor(Class templateClass, String newClassName, String... replacements)
/*     */   {
/*  58 */     String vmname = toVMClassName(templateClass);
/*  59 */     return tailor(templateClass.getClassLoader().getResourceAsStream(vmname + ".class"), vmname, newClassName, replacements);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static final byte[] tailor(InputStream image, String templateClassName, String newClassName, String... replacements)
/*     */   {
/*  78 */     DataInputStream in = new DataInputStream(image);
/*     */     try
/*     */     {
/*  81 */       ByteArrayOutputStream baos = new ByteArrayOutputStream(1024);
/*  82 */       DataOutputStream out = new DataOutputStream(baos);
/*     */       
/*     */ 
/*  85 */       long l = in.readLong();
/*  86 */       out.writeLong(l);
/*     */       
/*     */ 
/*  89 */       short count = in.readShort();
/*  90 */       out.writeShort(count);
/*     */       
/*     */ 
/*  93 */       for (int i = 0; i < count; i++) {
/*  94 */         byte tag = in.readByte();
/*  95 */         out.writeByte(tag);
/*  96 */         switch (tag)
/*     */         {
/*     */         case 0: 
/*     */           break;
/*     */         
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */         case 1: 
/* 106 */           String value = in.readUTF();
/* 107 */           if (value.equals(templateClassName)) {
/* 108 */             value = newClassName;
/*     */           } else {
/* 110 */             for (int j = 0; j < replacements.length; j += 2)
/* 111 */               if (value.equals(replacements[j])) {
/* 112 */                 value = replacements[(j + 1)];
/* 113 */                 break;
/*     */               }
/*     */           }
/* 116 */           out.writeUTF(value);
/*     */           
/* 118 */           break;
/*     */         
/*     */         case 3: 
/*     */         case 4: 
/* 122 */           out.writeInt(in.readInt());
/* 123 */           break;
/*     */         
/*     */         case 5: 
/*     */         case 6: 
/* 127 */           i++;
/* 128 */           out.writeLong(in.readLong());
/* 129 */           break;
/*     */         
/*     */         case 7: 
/*     */         case 8: 
/* 133 */           out.writeShort(in.readShort());
/* 134 */           break;
/*     */         
/*     */         case 9: 
/*     */         case 10: 
/*     */         case 11: 
/*     */         case 12: 
/* 140 */           out.writeInt(in.readInt());
/* 141 */           break;
/*     */         case 2: 
/*     */         default: 
/* 144 */           throw new IllegalArgumentException("Unknown constant type " + tag);
/*     */         }
/*     */         
/*     */       }
/*     */       
/* 149 */       byte[] buf = new byte['Ȁ'];
/*     */       int len;
/* 151 */       while ((len = in.read(buf)) > 0) {
/* 152 */         out.write(buf, 0, len);
/*     */       }
/* 154 */       in.close();
/* 155 */       out.close();
/*     */       
/*     */ 
/* 158 */       return baos.toByteArray();
/*     */     }
/*     */     catch (IOException e)
/*     */     {
/* 162 */       logger.log(Level.WARNING, "failed to tailor", e); }
/* 163 */     return null;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\bytecode\ClassTailor.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */