/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.xml.bind.v2.util.QNameMap;
/*     */ import java.util.HashMap;
/*     */ import java.util.HashSet;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import java.util.Set;
/*     */ import javax.xml.namespace.QName;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class NameBuilder
/*     */ {
/*  24 */   private Map<String, Integer> uriIndexMap = new HashMap();
/*  25 */   private Set<String> nonDefaultableNsUris = new HashSet();
/*  26 */   private Map<String, Integer> localNameIndexMap = new HashMap();
/*  27 */   private QNameMap<Integer> elementQNameIndexMap = new QNameMap();
/*  28 */   private QNameMap<Integer> attributeQNameIndexMap = new QNameMap();
/*     */   
/*     */   public Name createElementName(QName name) {
/*  31 */     return createElementName(name.getNamespaceURI(), name.getLocalPart());
/*     */   }
/*     */   
/*     */   public Name createElementName(String nsUri, String localName) {
/*  35 */     return createName(nsUri, localName, false, this.elementQNameIndexMap);
/*     */   }
/*     */   
/*     */   public Name createAttributeName(QName name) {
/*  39 */     return createAttributeName(name.getNamespaceURI(), name.getLocalPart());
/*     */   }
/*     */   
/*     */   public Name createAttributeName(String nsUri, String localName) {
/*  43 */     assert (nsUri.intern() == nsUri);
/*  44 */     assert (localName.intern() == localName);
/*     */     
/*  46 */     if (nsUri.length() == 0) {
/*  47 */       return new Name(allocIndex(this.attributeQNameIndexMap, "", localName), -1, nsUri, allocIndex(this.localNameIndexMap, localName), localName, true);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  55 */     this.nonDefaultableNsUris.add(nsUri);
/*  56 */     return createName(nsUri, localName, true, this.attributeQNameIndexMap);
/*     */   }
/*     */   
/*     */   private Name createName(String nsUri, String localName, boolean isAttribute, QNameMap<Integer> map)
/*     */   {
/*  61 */     assert (nsUri.intern() == nsUri);
/*  62 */     assert (localName.intern() == localName);
/*     */     
/*  64 */     return new Name(allocIndex(map, nsUri, localName), allocIndex(this.uriIndexMap, nsUri), nsUri, allocIndex(this.localNameIndexMap, localName), localName, isAttribute);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private int allocIndex(Map<String, Integer> map, String str)
/*     */   {
/*  74 */     Integer i = (Integer)map.get(str);
/*  75 */     if (i == null) {
/*  76 */       i = Integer.valueOf(map.size());
/*  77 */       map.put(str, i);
/*     */     }
/*  79 */     return i.intValue();
/*     */   }
/*     */   
/*     */   private int allocIndex(QNameMap<Integer> map, String nsUri, String localName) {
/*  83 */     Integer i = (Integer)map.get(nsUri, localName);
/*  84 */     if (i == null) {
/*  85 */       i = Integer.valueOf(map.size());
/*  86 */       map.put(nsUri, localName, i);
/*     */     }
/*  88 */     return i.intValue();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public NameList conclude()
/*     */   {
/*  95 */     boolean[] nsUriCannotBeDefaulted = new boolean[this.uriIndexMap.size()];
/*  96 */     for (Map.Entry<String, Integer> e : this.uriIndexMap.entrySet()) {
/*  97 */       nsUriCannotBeDefaulted[((Integer)e.getValue()).intValue()] = this.nonDefaultableNsUris.contains(e.getKey());
/*     */     }
/*     */     
/* 100 */     NameList r = new NameList(list(this.uriIndexMap), nsUriCannotBeDefaulted, list(this.localNameIndexMap), this.elementQNameIndexMap.size(), this.attributeQNameIndexMap.size());
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 107 */     this.uriIndexMap = null;
/* 108 */     this.localNameIndexMap = null;
/* 109 */     return r;
/*     */   }
/*     */   
/*     */   private String[] list(Map<String, Integer> map) {
/* 113 */     String[] r = new String[map.size()];
/* 114 */     for (Map.Entry<String, Integer> e : map.entrySet())
/* 115 */       r[((Integer)e.getValue()).intValue()] = ((String)e.getKey());
/* 116 */     return r;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\NameBuilder.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */