/*     */ package com.sun.xml.bind.v2.runtime.output;
/*     */ 
/*     */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*     */ import java.io.IOException;
/*     */ import javax.xml.stream.XMLEventFactory;
/*     */ import javax.xml.stream.XMLEventWriter;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.events.Attribute;
/*     */ import javax.xml.stream.events.Characters;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class XMLEventWriterOutput
/*     */   extends XmlOutputAbstractImpl
/*     */ {
/*     */   private final XMLEventWriter out;
/*     */   private final XMLEventFactory ef;
/*     */   private final Characters sp;
/*     */   
/*     */   public XMLEventWriterOutput(XMLEventWriter out)
/*     */   {
/*  28 */     this.out = out;
/*  29 */     this.ef = XMLEventFactory.newInstance();
/*  30 */     this.sp = this.ef.createCharacters(" ");
/*     */   }
/*     */   
/*     */   public void startDocument(XMLSerializer serializer, boolean fragment, int[] nsUriIndex2prefixIndex, NamespaceContextImpl nsContext)
/*     */     throws IOException, SAXException, XMLStreamException
/*     */   {
/*  36 */     super.startDocument(serializer, fragment, nsUriIndex2prefixIndex, nsContext);
/*  37 */     if (!fragment)
/*  38 */       this.out.add(this.ef.createStartDocument());
/*     */   }
/*     */   
/*     */   public void endDocument(boolean fragment) throws IOException, SAXException, XMLStreamException {
/*  42 */     if (!fragment) {
/*  43 */       this.out.add(this.ef.createEndDocument());
/*  44 */       this.out.flush();
/*     */     }
/*  46 */     super.endDocument(fragment);
/*     */   }
/*     */   
/*     */   public void beginStartTag(int prefix, String localName) throws IOException, XMLStreamException {
/*  50 */     this.out.add(this.ef.createStartElement(this.nsContext.getPrefix(prefix), this.nsContext.getNamespaceURI(prefix), localName));
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  56 */     NamespaceContextImpl.Element nse = this.nsContext.getCurrent();
/*  57 */     if (nse.count() > 0)
/*  58 */       for (int i = nse.count() - 1; i >= 0; i--) {
/*  59 */         String uri = nse.getNsUri(i);
/*  60 */         if ((uri.length() != 0) || (nse.getBase() != 1))
/*     */         {
/*  62 */           this.out.add(this.ef.createNamespace(nse.getPrefix(i), uri)); }
/*     */       }
/*     */   }
/*     */   
/*     */   public void attribute(int prefix, String localName, String value) throws IOException, XMLStreamException {
/*     */     Attribute att;
/*     */     Attribute att;
/*  69 */     if (prefix == -1) {
/*  70 */       att = this.ef.createAttribute(localName, value);
/*     */     } else {
/*  72 */       att = this.ef.createAttribute(this.nsContext.getPrefix(prefix), this.nsContext.getNamespaceURI(prefix), localName, value);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*  77 */     this.out.add(att);
/*     */   }
/*     */   
/*     */   public void endStartTag() throws IOException, SAXException
/*     */   {}
/*     */   
/*     */   public void endTag(int prefix, String localName) throws IOException, SAXException, XMLStreamException
/*     */   {
/*  85 */     this.out.add(this.ef.createEndElement(this.nsContext.getPrefix(prefix), this.nsContext.getNamespaceURI(prefix), localName));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void text(String value, boolean needsSeparatingWhitespace)
/*     */     throws IOException, SAXException, XMLStreamException
/*     */   {
/*  93 */     if (needsSeparatingWhitespace)
/*  94 */       this.out.add(this.sp);
/*  95 */     this.out.add(this.ef.createCharacters(value));
/*     */   }
/*     */   
/*     */   public void text(Pcdata value, boolean needsSeparatingWhitespace) throws IOException, SAXException, XMLStreamException {
/*  99 */     text(value.toString(), needsSeparatingWhitespace);
/*     */   }
/*     */   
/*     */   public void flush() throws IOException, XMLStreamException {
/* 103 */     this.out.flush();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\output\XMLEventWriterOutput.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */