/*     */ package com.sun.xml.bind.v2.runtime.reflect;
/*     */ 
/*     */ import com.sun.xml.bind.Util;
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.v2.model.core.Adapter;
/*     */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*     */ import com.sun.xml.bind.v2.model.nav.ReflectionNavigator;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.opt.OptimizedAccessorFactory;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Loader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Receiver;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext.State;
/*     */ import java.lang.reflect.Field;
/*     */ import java.lang.reflect.InvocationTargetException;
/*     */ import java.lang.reflect.Method;
/*     */ import java.lang.reflect.Modifier;
/*     */ import java.lang.reflect.Type;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import java.util.logging.Level;
/*     */ import java.util.logging.Logger;
/*     */ import javax.xml.bind.JAXBElement;
/*     */ import javax.xml.bind.annotation.adapters.XmlAdapter;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class Accessor<BeanT, ValueT>
/*     */   implements Receiver
/*     */ {
/*     */   public final Class<ValueT> valueType;
/*     */   
/*     */   public Class<ValueT> getValueType()
/*     */   {
/*  50 */     return this.valueType;
/*     */   }
/*     */   
/*     */   protected Accessor(Class<ValueT> valueType) {
/*  54 */     this.valueType = valueType;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Accessor<BeanT, ValueT> optimize()
/*     */   {
/*  64 */     return this;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract ValueT get(BeanT paramBeanT)
/*     */     throws AccessorException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract void set(BeanT paramBeanT, ValueT paramValueT)
/*     */     throws AccessorException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Object getUnadapted(BeanT bean)
/*     */     throws AccessorException
/*     */   {
/* 105 */     return get(bean);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setUnadapted(BeanT bean, Object value)
/*     */     throws AccessorException
/*     */   {
/* 115 */     set(bean, value);
/*     */   }
/*     */   
/*     */   public void receive(UnmarshallingContext.State state, Object o) throws SAXException {
/*     */     try {
/* 120 */       set(state.target, o);
/*     */     } catch (AccessorException e) {
/* 122 */       Loader.handleGenericException(e, true);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public final <T> Accessor<BeanT, T> adapt(Class<T> targetType, Class<? extends XmlAdapter<T, ValueT>> adapter)
/*     */   {
/* 131 */     return new AdaptedAccessor(targetType, this, adapter);
/*     */   }
/*     */   
/*     */   public final <T> Accessor<BeanT, T> adapt(Adapter<Type, Class> adapter) {
/* 135 */     return new AdaptedAccessor(Navigator.REFLECTION.erasure((Type)adapter.defaultType), this, (Class)adapter.adapterType);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 145 */   private static boolean accessWarned = false;
/*     */   
/*     */ 
/*     */ 
/*     */   public static class FieldReflection<BeanT, ValueT>
/*     */     extends Accessor<BeanT, ValueT>
/*     */   {
/*     */     public final Field f;
/*     */     
/* 154 */     private static final Logger logger = ;
/*     */     
/*     */ 
/*     */     public FieldReflection(Field f)
/*     */     {
/* 159 */       super();
/* 160 */       this.f = f;
/*     */       
/* 162 */       int mod = f.getModifiers();
/* 163 */       if ((!Modifier.isPublic(mod)) || (Modifier.isFinal(mod)) || (!Modifier.isPublic(f.getDeclaringClass().getModifiers()))) {
/*     */         try {
/* 165 */           f.setAccessible(true);
/*     */         } catch (SecurityException e) {
/* 167 */           if (!Accessor.accessWarned)
/*     */           {
/* 169 */             logger.log(Level.WARNING, Messages.UNABLE_TO_ACCESS_NON_PUBLIC_FIELD.format(new Object[] { f.getDeclaringClass().getName(), f.getName() }), e);
/*     */           }
/*     */           
/*     */ 
/* 173 */           Accessor.access$002(true);
/*     */         }
/*     */       }
/*     */     }
/*     */     
/*     */     public ValueT get(BeanT bean) {
/*     */       try {
/* 180 */         return (ValueT)this.f.get(bean);
/*     */       } catch (IllegalAccessException e) {
/* 182 */         throw new IllegalAccessError(e.getMessage());
/*     */       }
/*     */     }
/*     */     
/*     */     public void set(BeanT bean, ValueT value) {
/*     */       try {
/* 188 */         if (value == null)
/* 189 */           value = Accessor.uninitializedValues.get(this.valueType);
/* 190 */         this.f.set(bean, value);
/*     */       } catch (IllegalAccessException e) {
/* 192 */         throw new IllegalAccessError(e.getMessage());
/*     */       }
/*     */     }
/*     */     
/*     */     public Accessor<BeanT, ValueT> optimize()
/*     */     {
/* 198 */       Accessor<BeanT, ValueT> acc = OptimizedAccessorFactory.get(this.f);
/* 199 */       if (acc != null) {
/* 200 */         return acc;
/*     */       }
/* 202 */       return this;
/*     */     }
/*     */   }
/*     */   
/*     */   public static final class ReadOnlyFieldReflection<BeanT, ValueT>
/*     */     extends Accessor.FieldReflection<BeanT, ValueT>
/*     */   {
/*     */     public ReadOnlyFieldReflection(Field f)
/*     */     {
/* 211 */       super();
/*     */     }
/*     */     
/*     */ 
/*     */     public void set(BeanT bean, ValueT value) {}
/*     */     
/*     */ 
/*     */     public Accessor<BeanT, ValueT> optimize()
/*     */     {
/* 220 */       return this;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public static class GetterSetterReflection<BeanT, ValueT>
/*     */     extends Accessor<BeanT, ValueT>
/*     */   {
/*     */     public final Method getter;
/*     */     
/*     */     public final Method setter;
/*     */     
/* 232 */     private static final Logger logger = ;
/*     */     
/*     */     public GetterSetterReflection(Method getter, Method setter) {
/* 235 */       super();
/*     */       
/*     */ 
/*     */ 
/* 239 */       this.getter = getter;
/* 240 */       this.setter = setter;
/*     */       
/* 242 */       if (getter != null)
/* 243 */         makeAccessible(getter);
/* 244 */       if (setter != null)
/* 245 */         makeAccessible(setter);
/*     */     }
/*     */     
/*     */     private void makeAccessible(Method m) {
/* 249 */       if ((!Modifier.isPublic(m.getModifiers())) || (!Modifier.isPublic(m.getDeclaringClass().getModifiers()))) {
/*     */         try {
/* 251 */           m.setAccessible(true);
/*     */         } catch (SecurityException e) {
/* 253 */           if (!Accessor.accessWarned)
/*     */           {
/* 255 */             logger.log(Level.WARNING, Messages.UNABLE_TO_ACCESS_NON_PUBLIC_FIELD.format(new Object[] { m.getDeclaringClass().getName(), m.getName() }), e);
/*     */           }
/*     */           
/*     */ 
/* 259 */           Accessor.access$002(true);
/*     */         }
/*     */       }
/*     */     }
/*     */     
/*     */     public ValueT get(BeanT bean) throws AccessorException {
/*     */       try {
/* 266 */         return (ValueT)this.getter.invoke(bean, new Object[0]);
/*     */       } catch (IllegalAccessException e) {
/* 268 */         throw new IllegalAccessError(e.getMessage());
/*     */       } catch (InvocationTargetException e) {
/* 270 */         throw handleInvocationTargetException(e);
/*     */       }
/*     */     }
/*     */     
/*     */     public void set(BeanT bean, ValueT value) throws AccessorException {
/*     */       try {
/* 276 */         if (value == null)
/* 277 */           value = Accessor.uninitializedValues.get(this.valueType);
/* 278 */         this.setter.invoke(bean, new Object[] { value });
/*     */       } catch (IllegalAccessException e) {
/* 280 */         throw new IllegalAccessError(e.getMessage());
/*     */       } catch (InvocationTargetException e) {
/* 282 */         throw handleInvocationTargetException(e);
/*     */       }
/*     */     }
/*     */     
/*     */     private AccessorException handleInvocationTargetException(InvocationTargetException e)
/*     */     {
/* 288 */       Throwable t = e.getTargetException();
/* 289 */       if ((t instanceof RuntimeException))
/* 290 */         throw ((RuntimeException)t);
/* 291 */       if ((t instanceof Error)) {
/* 292 */         throw ((Error)t);
/*     */       }
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 299 */       return new AccessorException(t);
/*     */     }
/*     */     
/*     */     public Accessor<BeanT, ValueT> optimize()
/*     */     {
/* 304 */       if ((this.getter == null) || (this.setter == null))
/*     */       {
/* 306 */         return this;
/*     */       }
/* 308 */       Accessor<BeanT, ValueT> acc = OptimizedAccessorFactory.get(this.getter, this.setter);
/* 309 */       if (acc != null) {
/* 310 */         return acc;
/*     */       }
/* 312 */       return this;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static class GetterOnlyReflection<BeanT, ValueT>
/*     */     extends Accessor.GetterSetterReflection<BeanT, ValueT>
/*     */   {
/*     */     public GetterOnlyReflection(Method getter)
/*     */     {
/* 324 */       super(null);
/*     */     }
/*     */     
/*     */     public void set(BeanT bean, ValueT value) throws AccessorException
/*     */     {
/* 329 */       throw new AccessorException(Messages.NO_SETTER.format(new Object[] { this.getter.toString() }));
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static class SetterOnlyReflection<BeanT, ValueT>
/*     */     extends Accessor.GetterSetterReflection<BeanT, ValueT>
/*     */   {
/*     */     public SetterOnlyReflection(Method setter)
/*     */     {
/* 341 */       super(setter);
/*     */     }
/*     */     
/*     */     public ValueT get(BeanT bean) throws AccessorException
/*     */     {
/* 346 */       throw new AccessorException(Messages.NO_GETTER.format(new Object[] { this.setter.toString() }));
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/* 353 */   public static final Accessor ERROR = new Accessor(Object.class) {
/*     */     public Object get(Object o) {
/* 355 */       return null;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */     public void set(Object o, Object o1) {}
/*     */   };
/*     */   
/*     */ 
/* 365 */   public static final Accessor<JAXBElement, Object> JAXB_ELEMENT_VALUE = new Accessor(Object.class) {
/*     */     public Object get(JAXBElement jaxbElement) {
/* 367 */       return jaxbElement.getValue();
/*     */     }
/*     */     
/*     */     public void set(JAXBElement jaxbElement, Object o) {
/* 371 */       jaxbElement.setValue(o);
/*     */     }
/*     */   };
/*     */   
/*     */ 
/*     */ 
/*     */ 
/* 378 */   private static final Map<Class, Object> uninitializedValues = new HashMap();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   static
/*     */   {
/* 391 */     uninitializedValues.put(Byte.TYPE, Byte.valueOf((byte)0));
/* 392 */     uninitializedValues.put(Boolean.TYPE, Boolean.valueOf(false));
/* 393 */     uninitializedValues.put(Character.TYPE, Character.valueOf('\000'));
/* 394 */     uninitializedValues.put(Float.TYPE, Float.valueOf(0.0F));
/* 395 */     uninitializedValues.put(Double.TYPE, Double.valueOf(0.0D));
/* 396 */     uninitializedValues.put(Integer.TYPE, Integer.valueOf(0));
/* 397 */     uninitializedValues.put(Long.TYPE, Long.valueOf(0L));
/* 398 */     uninitializedValues.put(Short.TYPE, Short.valueOf((short)0));
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\Accessor.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */