/*      */ package org.codehaus.jackson.map;
/*      */ 
/*      */ import java.lang.annotation.Annotation;
/*      */ import java.util.ArrayList;
/*      */ import java.util.Collection;
/*      */ import java.util.Collections;
/*      */ import java.util.List;
/*      */ import org.codehaus.jackson.map.annotate.JsonSerialize.Inclusion;
/*      */ import org.codehaus.jackson.map.annotate.JsonSerialize.Typing;
/*      */ import org.codehaus.jackson.map.introspect.Annotated;
/*      */ import org.codehaus.jackson.map.introspect.AnnotatedClass;
/*      */ import org.codehaus.jackson.map.introspect.AnnotatedConstructor;
/*      */ import org.codehaus.jackson.map.introspect.AnnotatedField;
/*      */ import org.codehaus.jackson.map.introspect.AnnotatedMember;
/*      */ import org.codehaus.jackson.map.introspect.AnnotatedMethod;
/*      */ import org.codehaus.jackson.map.introspect.AnnotatedParameter;
/*      */ import org.codehaus.jackson.map.introspect.NopAnnotationIntrospector;
/*      */ import org.codehaus.jackson.map.introspect.VisibilityChecker;
/*      */ import org.codehaus.jackson.map.jsontype.NamedType;
/*      */ import org.codehaus.jackson.map.jsontype.TypeResolverBuilder;
/*      */ import org.codehaus.jackson.type.JavaType;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ public abstract class AnnotationIntrospector
/*      */ {
/*      */   public static class ReferenceProperty
/*      */   {
/*      */     private final Type _type;
/*      */     private final String _name;
/*      */     
/*      */     public static enum Type
/*      */     {
/*   50 */       MANAGED_REFERENCE, 
/*      */       
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*   58 */       BACK_REFERENCE;
/*      */       
/*      */ 
/*      */       private Type() {}
/*      */     }
/*      */     
/*      */     public ReferenceProperty(Type t, String n)
/*      */     {
/*   66 */       this._type = t;
/*   67 */       this._name = n;
/*      */     }
/*      */     
/*   70 */     public static ReferenceProperty managed(String name) { return new ReferenceProperty(Type.MANAGED_REFERENCE, name); }
/*   71 */     public static ReferenceProperty back(String name) { return new ReferenceProperty(Type.BACK_REFERENCE, name); }
/*      */     
/*   73 */     public Type getType() { return this._type; }
/*   74 */     public String getName() { return this._name; }
/*      */     
/*   76 */     public boolean isManagedReference() { return this._type == Type.MANAGED_REFERENCE; }
/*   77 */     public boolean isBackReference() { return this._type == Type.BACK_REFERENCE; }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public static AnnotationIntrospector nopInstance()
/*      */   {
/*   94 */     return NopAnnotationIntrospector.instance;
/*      */   }
/*      */   
/*      */   public static AnnotationIntrospector pair(AnnotationIntrospector a1, AnnotationIntrospector a2) {
/*   98 */     return new Pair(a1, a2);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Collection<AnnotationIntrospector> allIntrospectors()
/*      */   {
/*  119 */     return Collections.singletonList(this);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Collection<AnnotationIntrospector> allIntrospectors(Collection<AnnotationIntrospector> result)
/*      */   {
/*  133 */     result.add(this);
/*  134 */     return result;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract boolean isHandled(Annotation paramAnnotation);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract Boolean findCachability(AnnotatedClass paramAnnotatedClass);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract String findRootName(AnnotatedClass paramAnnotatedClass);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract String[] findPropertiesToIgnore(AnnotatedClass paramAnnotatedClass);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract Boolean findIgnoreUnknownProperties(AnnotatedClass paramAnnotatedClass);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Boolean isIgnorableType(AnnotatedClass ac)
/*      */   {
/*  215 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Object findFilterId(AnnotatedClass ac)
/*      */   {
/*  226 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public VisibilityChecker<?> findAutoDetectVisibility(AnnotatedClass ac, VisibilityChecker<?> checker)
/*      */   {
/*  245 */     return checker;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public TypeResolverBuilder<?> findTypeResolver(MapperConfig<?> config, AnnotatedClass ac, JavaType baseType)
/*      */   {
/*  272 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public TypeResolverBuilder<?> findPropertyTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType baseType)
/*      */   {
/*  294 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public TypeResolverBuilder<?> findPropertyContentTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType containerType)
/*      */   {
/*  318 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public List<NamedType> findSubtypes(Annotated a)
/*      */   {
/*  333 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public String findTypeName(AnnotatedClass ac)
/*      */   {
/*  344 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public ReferenceProperty findReferenceType(AnnotatedMember member)
/*      */   {
/*  360 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract boolean isIgnorableMethod(AnnotatedMethod paramAnnotatedMethod);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract boolean isIgnorableConstructor(AnnotatedConstructor paramAnnotatedConstructor);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract boolean isIgnorableField(AnnotatedField paramAnnotatedField);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Object findSerializer(Annotated am)
/*      */   {
/*  420 */     return findSerializer(am, null);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   @Deprecated
/*      */   public Object findSerializer(Annotated am, BeanProperty property)
/*      */   {
/*  429 */     if (property != null) {
/*  430 */       return findSerializer(am);
/*      */     }
/*  432 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Class<? extends JsonSerializer<?>> findKeySerializer(Annotated am)
/*      */   {
/*  445 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Class<? extends JsonSerializer<?>> findContentSerializer(Annotated am)
/*      */   {
/*  459 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public JsonSerialize.Inclusion findSerializationInclusion(Annotated a, JsonSerialize.Inclusion defValue)
/*      */   {
/*  473 */     return defValue;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract Class<?> findSerializationType(Annotated paramAnnotated);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Class<?> findSerializationKeyType(Annotated am, JavaType baseType)
/*      */   {
/*  496 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Class<?> findSerializationContentType(Annotated am, JavaType baseType)
/*      */   {
/*  508 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract JsonSerialize.Typing findSerializationTyping(Annotated paramAnnotated);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract Class<?>[] findSerializationViews(Annotated paramAnnotated);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract String[] findSerializationPropertyOrder(AnnotatedClass paramAnnotatedClass);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract Boolean findSerializationSortAlphabetically(AnnotatedClass paramAnnotatedClass);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract String findGettablePropertyName(AnnotatedMethod paramAnnotatedMethod);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract boolean hasAsValueAnnotation(AnnotatedMethod paramAnnotatedMethod);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract String findEnumValue(Enum<?> paramEnum);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract String findSerializablePropertyName(AnnotatedField paramAnnotatedField);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Object findDeserializer(Annotated am)
/*      */   {
/*  634 */     return findDeserializer(am, null);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   @Deprecated
/*      */   public Object findDeserializer(Annotated am, BeanProperty property)
/*      */   {
/*  649 */     if (property != null) {
/*  650 */       return findDeserializer(am);
/*      */     }
/*  652 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract Class<? extends KeyDeserializer> findKeyDeserializer(Annotated paramAnnotated);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract Class<? extends JsonDeserializer<?>> findContentDeserializer(Annotated paramAnnotated);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract Class<?> findDeserializationType(Annotated paramAnnotated, JavaType paramJavaType, String paramString);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract Class<?> findDeserializationKeyType(Annotated paramAnnotated, JavaType paramJavaType, String paramString);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract Class<?> findDeserializationContentType(Annotated paramAnnotated, JavaType paramJavaType, String paramString);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract String findSettablePropertyName(AnnotatedMethod paramAnnotatedMethod);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public boolean hasAnySetterAnnotation(AnnotatedMethod am)
/*      */   {
/*  762 */     return false;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public boolean hasAnyGetterAnnotation(AnnotatedMethod am)
/*      */   {
/*  777 */     return false;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public boolean hasCreatorAnnotation(Annotated a)
/*      */   {
/*  791 */     return false;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract String findDeserializablePropertyName(AnnotatedField paramAnnotatedField);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public abstract String findPropertyNameForParam(AnnotatedParameter paramAnnotatedParameter);
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public static class Pair
/*      */     extends AnnotationIntrospector
/*      */   {
/*      */     protected final AnnotationIntrospector _primary;
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     protected final AnnotationIntrospector _secondary;
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     public Pair(AnnotationIntrospector p, AnnotationIntrospector s)
/*      */     {
/*  853 */       this._primary = p;
/*  854 */       this._secondary = s;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     public static AnnotationIntrospector create(AnnotationIntrospector primary, AnnotationIntrospector secondary)
/*      */     {
/*  867 */       if (primary == null) {
/*  868 */         return secondary;
/*      */       }
/*  870 */       if (secondary == null) {
/*  871 */         return primary;
/*      */       }
/*  873 */       return new Pair(primary, secondary);
/*      */     }
/*      */     
/*      */     public Collection<AnnotationIntrospector> allIntrospectors()
/*      */     {
/*  878 */       return allIntrospectors(new ArrayList());
/*      */     }
/*      */     
/*      */ 
/*      */     public Collection<AnnotationIntrospector> allIntrospectors(Collection<AnnotationIntrospector> result)
/*      */     {
/*  884 */       this._primary.allIntrospectors(result);
/*  885 */       this._secondary.allIntrospectors(result);
/*  886 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */     public boolean isHandled(Annotation ann)
/*      */     {
/*  894 */       return (this._primary.isHandled(ann)) || (this._secondary.isHandled(ann));
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     public Boolean findCachability(AnnotatedClass ac)
/*      */     {
/*  906 */       Boolean result = this._primary.findCachability(ac);
/*  907 */       if (result == null) {
/*  908 */         result = this._secondary.findCachability(ac);
/*      */       }
/*  910 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public String findRootName(AnnotatedClass ac)
/*      */     {
/*  916 */       String name1 = this._primary.findRootName(ac);
/*  917 */       if (name1 == null)
/*  918 */         return this._secondary.findRootName(ac);
/*  919 */       if (name1.length() > 0) {
/*  920 */         return name1;
/*      */       }
/*      */       
/*  923 */       String name2 = this._secondary.findRootName(ac);
/*  924 */       return name2 == null ? name1 : name2;
/*      */     }
/*      */     
/*      */ 
/*      */     public String[] findPropertiesToIgnore(AnnotatedClass ac)
/*      */     {
/*  930 */       String[] result = this._primary.findPropertiesToIgnore(ac);
/*  931 */       if (result == null) {
/*  932 */         result = this._secondary.findPropertiesToIgnore(ac);
/*      */       }
/*  934 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public Boolean findIgnoreUnknownProperties(AnnotatedClass ac)
/*      */     {
/*  940 */       Boolean result = this._primary.findIgnoreUnknownProperties(ac);
/*  941 */       if (result == null) {
/*  942 */         result = this._secondary.findIgnoreUnknownProperties(ac);
/*      */       }
/*  944 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public Boolean isIgnorableType(AnnotatedClass ac)
/*      */     {
/*  950 */       Boolean result = this._primary.isIgnorableType(ac);
/*  951 */       if (result == null) {
/*  952 */         result = this._secondary.isIgnorableType(ac);
/*      */       }
/*  954 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public Object findFilterId(AnnotatedClass ac)
/*      */     {
/*  960 */       Object id = this._primary.findFilterId(ac);
/*  961 */       if (id == null) {
/*  962 */         id = this._secondary.findFilterId(ac);
/*      */       }
/*  964 */       return id;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     public VisibilityChecker<?> findAutoDetectVisibility(AnnotatedClass ac, VisibilityChecker<?> checker)
/*      */     {
/*  980 */       checker = this._secondary.findAutoDetectVisibility(ac, checker);
/*  981 */       return this._primary.findAutoDetectVisibility(ac, checker);
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     public TypeResolverBuilder<?> findTypeResolver(MapperConfig<?> config, AnnotatedClass ac, JavaType baseType)
/*      */     {
/*  994 */       TypeResolverBuilder<?> b = this._primary.findTypeResolver(config, ac, baseType);
/*  995 */       if (b == null) {
/*  996 */         b = this._secondary.findTypeResolver(config, ac, baseType);
/*      */       }
/*  998 */       return b;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */     public TypeResolverBuilder<?> findPropertyTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType baseType)
/*      */     {
/* 1005 */       TypeResolverBuilder<?> b = this._primary.findPropertyTypeResolver(config, am, baseType);
/* 1006 */       if (b == null) {
/* 1007 */         b = this._secondary.findPropertyTypeResolver(config, am, baseType);
/*      */       }
/* 1009 */       return b;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */     public TypeResolverBuilder<?> findPropertyContentTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType baseType)
/*      */     {
/* 1016 */       TypeResolverBuilder<?> b = this._primary.findPropertyContentTypeResolver(config, am, baseType);
/* 1017 */       if (b == null) {
/* 1018 */         b = this._secondary.findPropertyContentTypeResolver(config, am, baseType);
/*      */       }
/* 1020 */       return b;
/*      */     }
/*      */     
/*      */ 
/*      */     public List<NamedType> findSubtypes(Annotated a)
/*      */     {
/* 1026 */       List<NamedType> types1 = this._primary.findSubtypes(a);
/* 1027 */       List<NamedType> types2 = this._secondary.findSubtypes(a);
/* 1028 */       if ((types1 == null) || (types1.isEmpty())) return types2;
/* 1029 */       if ((types2 == null) || (types2.isEmpty())) return types1;
/* 1030 */       ArrayList<NamedType> result = new ArrayList(types1.size() + types2.size());
/* 1031 */       result.addAll(types1);
/* 1032 */       result.addAll(types2);
/* 1033 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public String findTypeName(AnnotatedClass ac)
/*      */     {
/* 1039 */       String name = this._primary.findTypeName(ac);
/* 1040 */       if ((name == null) || (name.length() == 0)) {
/* 1041 */         name = this._secondary.findTypeName(ac);
/*      */       }
/* 1043 */       return name;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */     public AnnotationIntrospector.ReferenceProperty findReferenceType(AnnotatedMember member)
/*      */     {
/* 1051 */       AnnotationIntrospector.ReferenceProperty ref = this._primary.findReferenceType(member);
/* 1052 */       if (ref == null) {
/* 1053 */         ref = this._secondary.findReferenceType(member);
/*      */       }
/* 1055 */       return ref;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */     public boolean isIgnorableMethod(AnnotatedMethod m)
/*      */     {
/* 1062 */       return (this._primary.isIgnorableMethod(m)) || (this._secondary.isIgnorableMethod(m));
/*      */     }
/*      */     
/*      */     public boolean isIgnorableConstructor(AnnotatedConstructor c)
/*      */     {
/* 1067 */       return (this._primary.isIgnorableConstructor(c)) || (this._secondary.isIgnorableConstructor(c));
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */     public boolean isIgnorableField(AnnotatedField f)
/*      */     {
/* 1075 */       return (this._primary.isIgnorableField(f)) || (this._secondary.isIgnorableField(f));
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */     public Object findSerializer(Annotated am, BeanProperty property)
/*      */     {
/* 1083 */       Object result = this._primary.findSerializer(am, property);
/*      */       
/*      */ 
/*      */ 
/*      */ 
/* 1088 */       if (result == null) {
/* 1089 */         result = this._secondary.findSerializer(am, property);
/*      */       }
/* 1091 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public Object findSerializer(Annotated am)
/*      */     {
/* 1097 */       Object result = this._primary.findSerializer(am);
/* 1098 */       if (result == null) {
/* 1099 */         result = this._secondary.findSerializer(am);
/*      */       }
/* 1101 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public Class<? extends JsonSerializer<?>> findKeySerializer(Annotated a)
/*      */     {
/* 1107 */       Class<? extends JsonSerializer<?>> result = this._primary.findKeySerializer(a);
/* 1108 */       if ((result == null) || (result == JsonSerializer.None.class)) {
/* 1109 */         result = this._secondary.findKeySerializer(a);
/*      */       }
/* 1111 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public Class<? extends JsonSerializer<?>> findContentSerializer(Annotated a)
/*      */     {
/* 1117 */       Class<? extends JsonSerializer<?>> result = this._primary.findContentSerializer(a);
/* 1118 */       if ((result == null) || (result == JsonSerializer.None.class)) {
/* 1119 */         result = this._secondary.findContentSerializer(a);
/*      */       }
/* 1121 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     public JsonSerialize.Inclusion findSerializationInclusion(Annotated a, JsonSerialize.Inclusion defValue)
/*      */     {
/* 1139 */       defValue = this._secondary.findSerializationInclusion(a, defValue);
/* 1140 */       defValue = this._primary.findSerializationInclusion(a, defValue);
/* 1141 */       return defValue;
/*      */     }
/*      */     
/*      */ 
/*      */     public Class<?> findSerializationType(Annotated a)
/*      */     {
/* 1147 */       Class<?> result = this._primary.findSerializationType(a);
/* 1148 */       if (result == null) {
/* 1149 */         result = this._secondary.findSerializationType(a);
/*      */       }
/* 1151 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public Class<?> findSerializationKeyType(Annotated am, JavaType baseType)
/*      */     {
/* 1157 */       Class<?> result = this._primary.findSerializationKeyType(am, baseType);
/* 1158 */       if (result == null) {
/* 1159 */         result = this._secondary.findSerializationKeyType(am, baseType);
/*      */       }
/* 1161 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public Class<?> findSerializationContentType(Annotated am, JavaType baseType)
/*      */     {
/* 1167 */       Class<?> result = this._primary.findSerializationContentType(am, baseType);
/* 1168 */       if (result == null) {
/* 1169 */         result = this._secondary.findSerializationContentType(am, baseType);
/*      */       }
/* 1171 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public JsonSerialize.Typing findSerializationTyping(Annotated a)
/*      */     {
/* 1177 */       JsonSerialize.Typing result = this._primary.findSerializationTyping(a);
/* 1178 */       if (result == null) {
/* 1179 */         result = this._secondary.findSerializationTyping(a);
/*      */       }
/* 1181 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     public Class<?>[] findSerializationViews(Annotated a)
/*      */     {
/* 1191 */       Class<?>[] result = this._primary.findSerializationViews(a);
/* 1192 */       if (result == null) {
/* 1193 */         result = this._secondary.findSerializationViews(a);
/*      */       }
/* 1195 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */     public String[] findSerializationPropertyOrder(AnnotatedClass ac)
/*      */     {
/* 1202 */       String[] result = this._primary.findSerializationPropertyOrder(ac);
/* 1203 */       if (result == null) {
/* 1204 */         result = this._secondary.findSerializationPropertyOrder(ac);
/*      */       }
/* 1206 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     public Boolean findSerializationSortAlphabetically(AnnotatedClass ac)
/*      */     {
/* 1216 */       Boolean result = this._primary.findSerializationSortAlphabetically(ac);
/* 1217 */       if (result == null) {
/* 1218 */         result = this._secondary.findSerializationSortAlphabetically(ac);
/*      */       }
/* 1220 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */     public String findGettablePropertyName(AnnotatedMethod am)
/*      */     {
/* 1228 */       String result = this._primary.findGettablePropertyName(am);
/* 1229 */       if (result == null) {
/* 1230 */         result = this._secondary.findGettablePropertyName(am);
/* 1231 */       } else if (result.length() == 0)
/*      */       {
/*      */ 
/*      */ 
/* 1235 */         String str2 = this._secondary.findGettablePropertyName(am);
/* 1236 */         if (str2 != null) {
/* 1237 */           result = str2;
/*      */         }
/*      */       }
/* 1240 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public boolean hasAsValueAnnotation(AnnotatedMethod am)
/*      */     {
/* 1246 */       return (this._primary.hasAsValueAnnotation(am)) || (this._secondary.hasAsValueAnnotation(am));
/*      */     }
/*      */     
/*      */ 
/*      */     public String findEnumValue(Enum<?> value)
/*      */     {
/* 1252 */       String result = this._primary.findEnumValue(value);
/* 1253 */       if (result == null) {
/* 1254 */         result = this._secondary.findEnumValue(value);
/*      */       }
/* 1256 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */     public String findSerializablePropertyName(AnnotatedField af)
/*      */     {
/* 1264 */       String result = this._primary.findSerializablePropertyName(af);
/* 1265 */       if (result == null) {
/* 1266 */         result = this._secondary.findSerializablePropertyName(af);
/* 1267 */       } else if (result.length() == 0)
/*      */       {
/*      */ 
/*      */ 
/* 1271 */         String str2 = this._secondary.findSerializablePropertyName(af);
/* 1272 */         if (str2 != null) {
/* 1273 */           result = str2;
/*      */         }
/*      */       }
/* 1276 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */     public Object findDeserializer(Annotated am)
/*      */     {
/* 1284 */       Object result = this._primary.findDeserializer(am);
/* 1285 */       if (result == null) {
/* 1286 */         result = this._secondary.findDeserializer(am);
/*      */       }
/* 1288 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public Object findDeserializer(Annotated am, BeanProperty property)
/*      */     {
/* 1294 */       Object result = this._primary.findDeserializer(am, property);
/* 1295 */       if (result == null) {
/* 1296 */         result = this._secondary.findDeserializer(am, property);
/*      */       }
/* 1298 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public Class<? extends KeyDeserializer> findKeyDeserializer(Annotated am)
/*      */     {
/* 1304 */       Class<? extends KeyDeserializer> result = this._primary.findKeyDeserializer(am);
/* 1305 */       if ((result == null) || (result == KeyDeserializer.None.class)) {
/* 1306 */         result = this._secondary.findKeyDeserializer(am);
/*      */       }
/* 1308 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public Class<? extends JsonDeserializer<?>> findContentDeserializer(Annotated am)
/*      */     {
/* 1314 */       Class<? extends JsonDeserializer<?>> result = this._primary.findContentDeserializer(am);
/* 1315 */       if ((result == null) || (result == JsonDeserializer.None.class)) {
/* 1316 */         result = this._secondary.findContentDeserializer(am);
/*      */       }
/* 1318 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */     public Class<?> findDeserializationType(Annotated am, JavaType baseType, String propName)
/*      */     {
/* 1325 */       Class<?> result = this._primary.findDeserializationType(am, baseType, propName);
/* 1326 */       if (result == null) {
/* 1327 */         result = this._secondary.findDeserializationType(am, baseType, propName);
/*      */       }
/* 1329 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */     public Class<?> findDeserializationKeyType(Annotated am, JavaType baseKeyType, String propName)
/*      */     {
/* 1336 */       Class<?> result = this._primary.findDeserializationKeyType(am, baseKeyType, propName);
/* 1337 */       if (result == null) {
/* 1338 */         result = this._secondary.findDeserializationKeyType(am, baseKeyType, propName);
/*      */       }
/* 1340 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */     public Class<?> findDeserializationContentType(Annotated am, JavaType baseContentType, String propName)
/*      */     {
/* 1347 */       Class<?> result = this._primary.findDeserializationContentType(am, baseContentType, propName);
/* 1348 */       if (result == null) {
/* 1349 */         result = this._secondary.findDeserializationContentType(am, baseContentType, propName);
/*      */       }
/* 1351 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     public String findSettablePropertyName(AnnotatedMethod am)
/*      */     {
/* 1360 */       String result = this._primary.findSettablePropertyName(am);
/* 1361 */       if (result == null) {
/* 1362 */         result = this._secondary.findSettablePropertyName(am);
/* 1363 */       } else if (result.length() == 0)
/*      */       {
/*      */ 
/*      */ 
/* 1367 */         String str2 = this._secondary.findSettablePropertyName(am);
/* 1368 */         if (str2 != null) {
/* 1369 */           result = str2;
/*      */         }
/*      */       }
/* 1372 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */     public boolean hasAnySetterAnnotation(AnnotatedMethod am)
/*      */     {
/* 1378 */       return (this._primary.hasAnySetterAnnotation(am)) || (this._secondary.hasAnySetterAnnotation(am));
/*      */     }
/*      */     
/*      */ 
/*      */     public boolean hasAnyGetterAnnotation(AnnotatedMethod am)
/*      */     {
/* 1384 */       return (this._primary.hasAnyGetterAnnotation(am)) || (this._secondary.hasAnyGetterAnnotation(am));
/*      */     }
/*      */     
/*      */ 
/*      */     public boolean hasCreatorAnnotation(Annotated a)
/*      */     {
/* 1390 */       return (this._primary.hasCreatorAnnotation(a)) || (this._secondary.hasCreatorAnnotation(a));
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */     public String findDeserializablePropertyName(AnnotatedField af)
/*      */     {
/* 1398 */       String result = this._primary.findDeserializablePropertyName(af);
/* 1399 */       if (result == null) {
/* 1400 */         result = this._secondary.findDeserializablePropertyName(af);
/* 1401 */       } else if (result.length() == 0)
/*      */       {
/*      */ 
/*      */ 
/* 1405 */         String str2 = this._secondary.findDeserializablePropertyName(af);
/* 1406 */         if (str2 != null) {
/* 1407 */           result = str2;
/*      */         }
/*      */       }
/* 1410 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */     public String findPropertyNameForParam(AnnotatedParameter param)
/*      */     {
/* 1418 */       String result = this._primary.findPropertyNameForParam(param);
/* 1419 */       if (result == null) {
/* 1420 */         result = this._secondary.findPropertyNameForParam(param);
/*      */       }
/* 1422 */       return result;
/*      */     }
/*      */   }
/*      */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\AnnotationIntrospector.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */