/*     */ package org.codehaus.jackson.map.ser;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.lang.reflect.Type;
/*     */ import java.util.HashSet;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import org.codehaus.jackson.JsonGenerationException;
/*     */ import org.codehaus.jackson.JsonGenerator;
/*     */ import org.codehaus.jackson.JsonNode;
/*     */ import org.codehaus.jackson.map.BeanProperty;
/*     */ import org.codehaus.jackson.map.JsonMappingException;
/*     */ import org.codehaus.jackson.map.JsonSerializer;
/*     */ import org.codehaus.jackson.map.ResolvableSerializer;
/*     */ import org.codehaus.jackson.map.SerializationConfig.Feature;
/*     */ import org.codehaus.jackson.map.SerializerProvider;
/*     */ import org.codehaus.jackson.map.TypeSerializer;
/*     */ import org.codehaus.jackson.map.annotate.JacksonStdImpl;
/*     */ import org.codehaus.jackson.map.ser.impl.PropertySerializerMap;
/*     */ import org.codehaus.jackson.map.ser.impl.PropertySerializerMap.SerializerAndMapResult;
/*     */ import org.codehaus.jackson.map.type.TypeFactory;
/*     */ import org.codehaus.jackson.node.ObjectNode;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ @JacksonStdImpl
/*     */ public class MapSerializer extends ContainerSerializerBase<Map<?, ?>> implements ResolvableSerializer
/*     */ {
/*  28 */   protected static final JavaType UNSPECIFIED_TYPE = ;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final BeanProperty _property;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final HashSet<String> _ignoredEntries;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final boolean _valueTypeIsStatic;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final JavaType _keyType;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final JavaType _valueType;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected JsonSerializer<Object> _keySerializer;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected JsonSerializer<Object> _valueSerializer;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final TypeSerializer _valueTypeSerializer;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected PropertySerializerMap _dynamicValueSerializers;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected MapSerializer()
/*     */   {
/*  88 */     this((HashSet)null, null, null, false, null, null, null, null);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @Deprecated
/*     */   protected MapSerializer(HashSet<String> ignoredEntries, JavaType valueType, boolean valueTypeIsStatic, TypeSerializer vts)
/*     */   {
/* 101 */     this(ignoredEntries, UNSPECIFIED_TYPE, valueType, valueTypeIsStatic, vts, null, null, null);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @Deprecated
/*     */   protected MapSerializer(HashSet<String> ignoredEntries, JavaType keyType, JavaType valueType, boolean valueTypeIsStatic, TypeSerializer vts, JsonSerializer<Object> keySerializer, BeanProperty property)
/*     */   {
/* 114 */     this(ignoredEntries, keyType, valueType, valueTypeIsStatic, vts, keySerializer, null, property);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected MapSerializer(HashSet<String> ignoredEntries, JavaType keyType, JavaType valueType, boolean valueTypeIsStatic, TypeSerializer vts, JsonSerializer<Object> keySerializer, JsonSerializer<Object> valueSerializer, BeanProperty property)
/*     */   {
/* 123 */     super(Map.class, false);
/* 124 */     this._property = property;
/* 125 */     this._ignoredEntries = ignoredEntries;
/* 126 */     this._keyType = keyType;
/* 127 */     this._valueType = valueType;
/* 128 */     this._valueTypeIsStatic = valueTypeIsStatic;
/* 129 */     this._valueTypeSerializer = vts;
/* 130 */     this._keySerializer = keySerializer;
/* 131 */     this._valueSerializer = valueSerializer;
/* 132 */     this._dynamicValueSerializers = PropertySerializerMap.emptyMap();
/*     */   }
/*     */   
/*     */ 
/*     */   public ContainerSerializerBase<?> _withValueTypeSerializer(TypeSerializer vts)
/*     */   {
/* 138 */     MapSerializer ms = new MapSerializer(this._ignoredEntries, this._keyType, this._valueType, this._valueTypeIsStatic, vts, this._keySerializer, this._valueSerializer, this._property);
/*     */     
/* 140 */     if (this._valueSerializer != null) {
/* 141 */       ms._valueSerializer = this._valueSerializer;
/*     */     }
/* 143 */     return ms;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @Deprecated
/*     */   public static MapSerializer construct(String[] ignoredList, JavaType mapType, boolean staticValueType, TypeSerializer vts, BeanProperty property)
/*     */   {
/* 162 */     return construct(ignoredList, mapType, staticValueType, vts, property, null, null);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public static MapSerializer construct(String[] ignoredList, JavaType mapType, boolean staticValueType, TypeSerializer vts, BeanProperty property, JsonSerializer<Object> keySerializer, JsonSerializer<Object> valueSerializer)
/*     */   {
/* 169 */     HashSet<String> ignoredEntries = toSet(ignoredList);
/*     */     JavaType keyType;
/*     */     JavaType keyType;
/* 172 */     JavaType valueType; if (mapType == null) { JavaType valueType;
/* 173 */       keyType = valueType = UNSPECIFIED_TYPE;
/*     */     } else {
/* 175 */       keyType = mapType.getKeyType();
/* 176 */       valueType = mapType.getContentType();
/*     */     }
/*     */     
/* 179 */     if (!staticValueType) {
/* 180 */       staticValueType = (valueType != null) && (valueType.isFinal());
/*     */     }
/* 182 */     return new MapSerializer(ignoredEntries, keyType, valueType, staticValueType, vts, keySerializer, valueSerializer, property);
/*     */   }
/*     */   
/*     */   private static HashSet<String> toSet(String[] ignoredEntries)
/*     */   {
/* 187 */     if ((ignoredEntries == null) || (ignoredEntries.length == 0)) {
/* 188 */       return null;
/*     */     }
/* 190 */     HashSet<String> result = new HashSet(ignoredEntries.length);
/* 191 */     for (String prop : ignoredEntries) {
/* 192 */       result.add(prop);
/*     */     }
/* 194 */     return result;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void serialize(Map<?, ?> value, JsonGenerator jgen, SerializerProvider provider)
/*     */     throws IOException, JsonGenerationException
/*     */   {
/* 207 */     jgen.writeStartObject();
/* 208 */     if (!value.isEmpty()) {
/* 209 */       if (this._valueSerializer != null) {
/* 210 */         serializeFieldsUsing(value, jgen, provider, this._valueSerializer);
/*     */       } else {
/* 212 */         serializeFields(value, jgen, provider);
/*     */       }
/*     */     }
/* 215 */     jgen.writeEndObject();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void serializeWithType(Map<?, ?> value, JsonGenerator jgen, SerializerProvider provider, TypeSerializer typeSer)
/*     */     throws IOException, JsonGenerationException
/*     */   {
/* 223 */     typeSer.writeTypePrefixForObject(value, jgen);
/* 224 */     if (!value.isEmpty()) {
/* 225 */       if (this._valueSerializer != null) {
/* 226 */         serializeFieldsUsing(value, jgen, provider, this._valueSerializer);
/*     */       } else {
/* 228 */         serializeFields(value, jgen, provider);
/*     */       }
/*     */     }
/* 231 */     typeSer.writeTypeSuffixForObject(value, jgen);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected void serializeFields(Map<?, ?> value, JsonGenerator jgen, SerializerProvider provider)
/*     */     throws IOException, JsonGenerationException
/*     */   {
/* 247 */     if (this._valueTypeSerializer != null) {
/* 248 */       serializeTypedFields(value, jgen, provider);
/* 249 */       return;
/*     */     }
/* 251 */     JsonSerializer<Object> keySerializer = this._keySerializer;
/*     */     
/* 253 */     HashSet<String> ignored = this._ignoredEntries;
/* 254 */     boolean skipNulls = !provider.isEnabled(SerializationConfig.Feature.WRITE_NULL_MAP_VALUES);
/*     */     
/* 256 */     PropertySerializerMap serializers = this._dynamicValueSerializers;
/*     */     
/* 258 */     for (Map.Entry<?, ?> entry : value.entrySet()) {
/* 259 */       Object valueElem = entry.getValue();
/*     */       
/* 261 */       Object keyElem = entry.getKey();
/* 262 */       if (keyElem == null) {
/* 263 */         provider.getNullKeySerializer().serialize(null, jgen, provider);
/*     */       }
/*     */       else {
/* 266 */         if (((skipNulls) && (valueElem == null)) || (
/*     */         
/* 268 */           (ignored != null) && (ignored.contains(keyElem)))) continue;
/* 269 */         keySerializer.serialize(keyElem, jgen, provider);
/*     */       }
/*     */       
/*     */ 
/* 273 */       if (valueElem == null) {
/* 274 */         provider.defaultSerializeNull(jgen);
/*     */       } else {
/* 276 */         Class<?> cc = valueElem.getClass();
/* 277 */         JsonSerializer<Object> serializer = serializers.serializerFor(cc);
/* 278 */         if (serializer == null) {
/* 279 */           if (this._valueType.hasGenericTypes()) {
/* 280 */             serializer = _findAndAddDynamic(serializers, this._valueType.forcedNarrowBy(cc), provider);
/*     */           } else {
/* 282 */             serializer = _findAndAddDynamic(serializers, cc, provider);
/*     */           }
/* 284 */           serializers = this._dynamicValueSerializers;
/*     */         }
/*     */         try {
/* 287 */           serializer.serialize(valueElem, jgen, provider);
/*     */         }
/*     */         catch (Exception e) {
/* 290 */           String keyDesc = "" + keyElem;
/* 291 */           wrapAndThrow(provider, e, value, keyDesc);
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected void serializeFieldsUsing(Map<?, ?> value, JsonGenerator jgen, SerializerProvider provider, JsonSerializer<Object> ser)
/*     */     throws IOException, JsonGenerationException
/*     */   {
/* 306 */     JsonSerializer<Object> keySerializer = this._keySerializer;
/* 307 */     HashSet<String> ignored = this._ignoredEntries;
/* 308 */     TypeSerializer typeSer = this._valueTypeSerializer;
/* 309 */     boolean skipNulls = !provider.isEnabled(SerializationConfig.Feature.WRITE_NULL_MAP_VALUES);
/*     */     
/* 311 */     for (Map.Entry<?, ?> entry : value.entrySet()) {
/* 312 */       Object valueElem = entry.getValue();
/* 313 */       Object keyElem = entry.getKey();
/* 314 */       if (keyElem == null) {
/* 315 */         provider.getNullKeySerializer().serialize(null, jgen, provider);
/*     */       }
/*     */       else {
/* 318 */         if (((skipNulls) && (valueElem == null)) || (
/* 319 */           (ignored != null) && (ignored.contains(keyElem)))) continue;
/* 320 */         keySerializer.serialize(keyElem, jgen, provider);
/*     */       }
/* 322 */       if (valueElem == null) {
/* 323 */         provider.defaultSerializeNull(jgen);
/*     */       } else {
/*     */         try {
/* 326 */           if (typeSer == null) {
/* 327 */             ser.serialize(valueElem, jgen, provider);
/*     */           } else {
/* 329 */             ser.serializeWithType(valueElem, jgen, provider, typeSer);
/*     */           }
/*     */         }
/*     */         catch (Exception e) {
/* 333 */           String keyDesc = "" + keyElem;
/* 334 */           wrapAndThrow(provider, e, value, keyDesc);
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   protected void serializeTypedFields(Map<?, ?> value, JsonGenerator jgen, SerializerProvider provider)
/*     */     throws IOException, JsonGenerationException
/*     */   {
/* 343 */     JsonSerializer<Object> keySerializer = this._keySerializer;
/* 344 */     JsonSerializer<Object> prevValueSerializer = null;
/* 345 */     Class<?> prevValueClass = null;
/* 346 */     HashSet<String> ignored = this._ignoredEntries;
/* 347 */     boolean skipNulls = !provider.isEnabled(SerializationConfig.Feature.WRITE_NULL_MAP_VALUES);
/*     */     
/* 349 */     for (Map.Entry<?, ?> entry : value.entrySet()) {
/* 350 */       Object valueElem = entry.getValue();
/*     */       
/* 352 */       Object keyElem = entry.getKey();
/* 353 */       if (keyElem == null) {
/* 354 */         provider.getNullKeySerializer().serialize(null, jgen, provider);
/*     */       }
/*     */       else {
/* 357 */         if (((skipNulls) && (valueElem == null)) || (
/*     */         
/* 359 */           (ignored != null) && (ignored.contains(keyElem)))) continue;
/* 360 */         keySerializer.serialize(keyElem, jgen, provider);
/*     */       }
/*     */       
/*     */ 
/* 364 */       if (valueElem == null) {
/* 365 */         provider.defaultSerializeNull(jgen);
/*     */       } else {
/* 367 */         Class<?> cc = valueElem.getClass();
/*     */         JsonSerializer<Object> currSerializer;
/* 369 */         JsonSerializer<Object> currSerializer; if (cc == prevValueClass) {
/* 370 */           currSerializer = prevValueSerializer;
/*     */         } else {
/* 372 */           currSerializer = provider.findValueSerializer(cc, this._property);
/* 373 */           prevValueSerializer = currSerializer;
/* 374 */           prevValueClass = cc;
/*     */         }
/*     */         try {
/* 377 */           currSerializer.serializeWithType(valueElem, jgen, provider, this._valueTypeSerializer);
/*     */         }
/*     */         catch (Exception e) {
/* 380 */           String keyDesc = "" + keyElem;
/* 381 */           wrapAndThrow(provider, e, value, keyDesc);
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public JsonNode getSchema(SerializerProvider provider, Type typeHint)
/*     */   {
/* 390 */     ObjectNode o = createSchemaNode("object", true);
/*     */     
/*     */ 
/* 393 */     return o;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void resolve(SerializerProvider provider)
/*     */     throws JsonMappingException
/*     */   {
/* 403 */     if ((this._valueTypeIsStatic) && (this._valueSerializer == null)) {
/* 404 */       this._valueSerializer = provider.findValueSerializer(this._valueType, this._property);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 413 */     if (this._keySerializer == null) {
/* 414 */       this._keySerializer = provider.findKeySerializer(this._keyType, this._property);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final JsonSerializer<Object> _findAndAddDynamic(PropertySerializerMap map, Class<?> type, SerializerProvider provider)
/*     */     throws JsonMappingException
/*     */   {
/* 427 */     PropertySerializerMap.SerializerAndMapResult result = map.findAndAddSerializer(type, provider, this._property);
/*     */     
/* 429 */     if (map != result.map) {
/* 430 */       this._dynamicValueSerializers = result.map;
/*     */     }
/* 432 */     return result.serializer;
/*     */   }
/*     */   
/*     */   protected final JsonSerializer<Object> _findAndAddDynamic(PropertySerializerMap map, JavaType type, SerializerProvider provider)
/*     */     throws JsonMappingException
/*     */   {
/* 438 */     PropertySerializerMap.SerializerAndMapResult result = map.findAndAddSerializer(type, provider, this._property);
/* 439 */     if (map != result.map) {
/* 440 */       this._dynamicValueSerializers = result.map;
/*     */     }
/* 442 */     return result.serializer;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\ser\MapSerializer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */