/*      */ package org.codehaus.jackson.map.type;
/*      */ 
/*      */ import java.lang.reflect.GenericArrayType;
/*      */ import java.lang.reflect.ParameterizedType;
/*      */ import java.lang.reflect.Type;
/*      */ import java.lang.reflect.TypeVariable;
/*      */ import java.lang.reflect.WildcardType;
/*      */ import java.util.Collection;
/*      */ import java.util.List;
/*      */ import java.util.Map;
/*      */ import org.codehaus.jackson.map.util.ArrayBuilders;
/*      */ import org.codehaus.jackson.type.JavaType;
/*      */ import org.codehaus.jackson.type.TypeReference;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ public final class TypeFactory
/*      */ {
/*      */   @Deprecated
/*   50 */   public static final TypeFactory instance = new TypeFactory();
/*      */   
/*   52 */   private static final JavaType[] NO_TYPES = new JavaType[0];
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   protected final TypeModifier[] _modifiers;
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   protected final TypeParser _parser;
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private TypeFactory()
/*      */   {
/*   71 */     this._parser = new TypeParser(this);
/*   72 */     this._modifiers = null;
/*      */   }
/*      */   
/*      */   protected TypeFactory(TypeParser p, TypeModifier[] mods) {
/*   76 */     this._parser = p;
/*   77 */     this._modifiers = mods;
/*      */   }
/*      */   
/*      */   public TypeFactory withModifier(TypeModifier mod)
/*      */   {
/*   82 */     if (this._modifiers == null) {
/*   83 */       return new TypeFactory(this._parser, new TypeModifier[] { mod });
/*      */     }
/*   85 */     return new TypeFactory(this._parser, (TypeModifier[])ArrayBuilders.insertInListNoDup(this._modifiers, mod));
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public static TypeFactory defaultInstance()
/*      */   {
/*   95 */     return instance;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public static JavaType unknownType()
/*      */   {
/*  111 */     return defaultInstance()._unknownType();
/*      */   }
/*      */   
/*      */   public static Class<?> rawClass(Type t) {
/*  115 */     if ((t instanceof Class)) {
/*  116 */       return (Class)t;
/*      */     }
/*      */     
/*  119 */     return defaultInstance().constructType(t).getRawClass();
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   @Deprecated
/*      */   public static JavaType type(Type t)
/*      */   {
/*  130 */     return instance._constructType(t, null);
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType type(Type type, Class<?> context) {
/*  135 */     return instance.constructType(type, context);
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType type(Type type, JavaType context) {
/*  140 */     return instance.constructType(type, context);
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType type(Type type, TypeBindings bindings) {
/*  145 */     return instance._constructType(type, bindings);
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType type(TypeReference<?> ref) {
/*  150 */     return instance.constructType(ref.getType());
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType arrayType(Class<?> elementType) {
/*  155 */     return instance.constructArrayType(instance.constructType(elementType));
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType arrayType(JavaType elementType) {
/*  160 */     return instance.constructArrayType(elementType);
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType collectionType(Class<? extends Collection> collectionType, Class<?> elementType)
/*      */   {
/*  166 */     return instance.constructCollectionType(collectionType, instance.constructType(elementType));
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType collectionType(Class<? extends Collection> collectionType, JavaType elementType)
/*      */   {
/*  172 */     return instance.constructCollectionType(collectionType, elementType);
/*      */   }
/*      */   
/*      */ 
/*      */   @Deprecated
/*      */   public static JavaType mapType(Class<? extends Map> mapClass, Class<?> keyType, Class<?> valueType)
/*      */   {
/*  179 */     return instance.constructMapType(mapClass, type(keyType), instance.constructType(valueType));
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType mapType(Class<? extends Map> mapType, JavaType keyType, JavaType valueType)
/*      */   {
/*  185 */     return instance.constructMapType(mapType, keyType, valueType);
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType parametricType(Class<?> parametrized, Class<?>... parameterClasses) {
/*  190 */     return instance.constructParametricType(parametrized, parameterClasses);
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType parametricType(Class<?> parametrized, JavaType... parameterTypes) {
/*  195 */     return instance.constructParametricType(parametrized, parameterTypes);
/*      */   }
/*      */   
/*      */   public static JavaType fromCanonical(String canonical) throws IllegalArgumentException {
/*  199 */     return instance.constructFromCanonical(canonical);
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType specialize(JavaType baseType, Class<?> subclass) {
/*  204 */     return instance.constructSpecializedType(baseType, subclass);
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType fastSimpleType(Class<?> cls) {
/*  209 */     return instance.uncheckedSimpleType(cls);
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType[] findParameterTypes(Class<?> clz, Class<?> expType) {
/*  214 */     return instance.findTypeParameters(clz, expType);
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType[] findParameterTypes(Class<?> clz, Class<?> expType, TypeBindings bindings) {
/*  219 */     return instance.findTypeParameters(clz, expType, bindings);
/*      */   }
/*      */   
/*      */   @Deprecated
/*      */   public static JavaType[] findParameterTypes(JavaType type, Class<?> expType) {
/*  224 */     return instance.findTypeParameters(type, expType);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   @Deprecated
/*      */   public static JavaType fromClass(Class<?> clz)
/*      */   {
/*  247 */     return instance._fromClass(clz, null);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   @Deprecated
/*      */   public static JavaType fromTypeReference(TypeReference<?> ref)
/*      */   {
/*  261 */     return type(ref.getType());
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   @Deprecated
/*      */   public static JavaType fromType(Type type)
/*      */   {
/*  274 */     return instance._constructType(type, null);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public JavaType constructSpecializedType(JavaType baseType, Class<?> subclass)
/*      */   {
/*  293 */     if ((baseType instanceof SimpleType))
/*      */     {
/*  295 */       if ((subclass.isArray()) || (Map.class.isAssignableFrom(subclass)) || (Collection.class.isAssignableFrom(subclass)))
/*      */       {
/*      */ 
/*      */ 
/*  299 */         if (!baseType.getRawClass().isAssignableFrom(subclass)) {
/*  300 */           throw new IllegalArgumentException("Class " + subclass.getClass().getName() + " not subtype of " + baseType);
/*      */         }
/*      */         
/*  303 */         JavaType subtype = instance._fromClass(subclass, new TypeBindings(this, baseType.getRawClass()));
/*      */         
/*  305 */         Object h = baseType.getValueHandler();
/*  306 */         if (h != null) {
/*  307 */           subtype.setValueHandler(h);
/*      */         }
/*  309 */         h = baseType.getTypeHandler();
/*  310 */         if (h != null) {
/*  311 */           subtype = subtype.withTypeHandler(h);
/*      */         }
/*  313 */         return subtype;
/*      */       }
/*      */     }
/*      */     
/*  317 */     return baseType.narrowBy(subclass);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public JavaType constructFromCanonical(String canonical)
/*      */     throws IllegalArgumentException
/*      */   {
/*  334 */     return this._parser.parse(canonical);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public JavaType[] findTypeParameters(JavaType type, Class<?> expType)
/*      */   {
/*  358 */     Class<?> raw = type.getRawClass();
/*  359 */     if (raw == expType)
/*      */     {
/*  361 */       int count = type.containedTypeCount();
/*  362 */       if (count == 0) return null;
/*  363 */       JavaType[] result = new JavaType[count];
/*  364 */       for (int i = 0; i < count; i++) {
/*  365 */         result[i] = type.containedType(i);
/*      */       }
/*  367 */       return result;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  375 */     return findTypeParameters(raw, expType, new TypeBindings(this, type));
/*      */   }
/*      */   
/*      */   public JavaType[] findTypeParameters(Class<?> clz, Class<?> expType) {
/*  379 */     return findTypeParameters(clz, expType, new TypeBindings(this, clz));
/*      */   }
/*      */   
/*      */ 
/*      */   public JavaType[] findTypeParameters(Class<?> clz, Class<?> expType, TypeBindings bindings)
/*      */   {
/*  385 */     HierarchicType subType = _findSuperTypeChain(clz, expType);
/*      */     
/*  387 */     if (subType == null) {
/*  388 */       throw new IllegalArgumentException("Class " + clz.getName() + " is not a subtype of " + expType.getName());
/*      */     }
/*      */     
/*  391 */     HierarchicType superType = subType;
/*  392 */     while (superType.getSuperType() != null) {
/*  393 */       superType = superType.getSuperType();
/*  394 */       Class<?> raw = superType.getRawClass();
/*  395 */       TypeBindings newBindings = new TypeBindings(this, raw);
/*  396 */       if (superType.isGeneric()) {
/*  397 */         ParameterizedType pt = superType.asGeneric();
/*  398 */         Type[] actualTypes = pt.getActualTypeArguments();
/*  399 */         TypeVariable<?>[] vars = raw.getTypeParameters();
/*  400 */         int len = actualTypes.length;
/*  401 */         for (int i = 0; i < len; i++) {
/*  402 */           String name = vars[i].getName();
/*  403 */           JavaType type = instance._constructType(actualTypes[i], bindings);
/*  404 */           newBindings.addBinding(name, type);
/*      */         }
/*      */       }
/*  407 */       bindings = newBindings;
/*      */     }
/*      */     
/*      */ 
/*  411 */     if (!superType.isGeneric()) {
/*  412 */       return null;
/*      */     }
/*  414 */     return bindings.typesAsArray();
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public JavaType constructType(Type type)
/*      */   {
/*  424 */     return _constructType(type, null);
/*      */   }
/*      */   
/*      */   public JavaType constructType(Type type, TypeBindings bindings) {
/*  428 */     return _constructType(type, bindings);
/*      */   }
/*      */   
/*      */   public JavaType constructType(TypeReference<?> typeRef) {
/*  432 */     return _constructType(typeRef.getType(), null);
/*      */   }
/*      */   
/*      */   public JavaType constructType(Type type, Class<?> context) {
/*  436 */     return _constructType(type, new TypeBindings(this, context));
/*      */   }
/*      */   
/*      */   public JavaType constructType(Type type, JavaType context) {
/*  440 */     return _constructType(type, new TypeBindings(this, context));
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public JavaType _constructType(Type type, TypeBindings context)
/*      */   {
/*      */     JavaType resultType;
/*      */     
/*      */ 
/*      */ 
/*  453 */     if ((type instanceof Class)) {
/*  454 */       Class<?> cls = (Class)type;
/*      */       
/*      */ 
/*      */ 
/*  458 */       if (context == null) {
/*  459 */         context = new TypeBindings(this, cls);
/*      */       }
/*  461 */       resultType = _fromClass(cls, context);
/*      */     } else {
/*      */       JavaType resultType;
/*  464 */       if ((type instanceof ParameterizedType)) {
/*  465 */         resultType = _fromParamType((ParameterizedType)type, context);
/*      */       } else { JavaType resultType;
/*  467 */         if ((type instanceof GenericArrayType)) {
/*  468 */           resultType = _fromArrayType((GenericArrayType)type, context);
/*      */         } else { JavaType resultType;
/*  470 */           if ((type instanceof TypeVariable)) {
/*  471 */             resultType = _fromVariable((TypeVariable)type, context);
/*      */           } else { JavaType resultType;
/*  473 */             if ((type instanceof WildcardType)) {
/*  474 */               resultType = _fromWildcard((WildcardType)type, context);
/*      */             }
/*      */             else
/*  477 */               throw new IllegalArgumentException("Unrecognized Type: " + type.toString());
/*      */           }
/*      */         }
/*      */       }
/*      */     }
/*      */     JavaType resultType;
/*  483 */     if ((this._modifiers != null) && (!resultType.isContainerType())) {
/*  484 */       for (TypeModifier mod : this._modifiers) {
/*  485 */         resultType = mod.modifyType(resultType, type, context, this);
/*      */       }
/*      */     }
/*  488 */     return resultType;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   protected ArrayType constructArrayType(Class<?> elementType)
/*      */   {
/*  504 */     return ArrayType.construct(_constructType(elementType, null));
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   protected ArrayType constructArrayType(JavaType elementType)
/*      */   {
/*  514 */     return ArrayType.construct(elementType);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public CollectionType constructCollectionType(Class<? extends Collection> collectionClass, Class<?> elementClass)
/*      */   {
/*  525 */     return CollectionType.construct(collectionClass, constructType(elementClass));
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public CollectionType constructCollectionType(Class<? extends Collection> collectionClass, JavaType elementType)
/*      */   {
/*  536 */     return CollectionType.construct(collectionClass, elementType);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public CollectionLikeType constructCollectionLikeType(Class<?> collectionClass, Class<?> elementClass)
/*      */   {
/*  548 */     return CollectionLikeType.construct(collectionClass, constructType(elementClass));
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public CollectionLikeType constructCollectionLikeType(Class<?> collectionClass, JavaType elementType)
/*      */   {
/*  560 */     return CollectionLikeType.construct(collectionClass, elementType);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public MapType constructMapType(Class<? extends Map> mapClass, JavaType keyType, JavaType valueType)
/*      */   {
/*  573 */     return MapType.construct(mapClass, keyType, valueType);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public MapType constructMapType(Class<? extends Map> mapClass, Class<?> keyClass, Class<?> valueClass)
/*      */   {
/*  586 */     return MapType.construct(mapClass, constructType(keyClass), constructType(valueClass));
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public MapLikeType constructMapLikeType(Class<?> mapClass, JavaType keyType, JavaType valueType)
/*      */   {
/*  598 */     return MapLikeType.construct(mapClass, keyType, valueType);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public MapLikeType constructMapLikeType(Class<?> mapClass, Class<?> keyClass, Class<?> valueClass)
/*      */   {
/*  610 */     return MapType.construct(mapClass, constructType(keyClass), constructType(valueClass));
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public JavaType constructSimpleType(Class<?> rawType, JavaType[] parameterTypes)
/*      */   {
/*  621 */     TypeVariable<?>[] typeVars = rawType.getTypeParameters();
/*  622 */     if (typeVars.length != parameterTypes.length) {
/*  623 */       throw new IllegalArgumentException("Parameter type mismatch for " + rawType.getName() + ": expected " + typeVars.length + " parameters, was given " + parameterTypes.length);
/*      */     }
/*      */     
/*  626 */     String[] names = new String[typeVars.length];
/*  627 */     int i = 0; for (int len = typeVars.length; i < len; i++) {
/*  628 */       names[i] = typeVars[i].getName();
/*      */     }
/*  630 */     JavaType resultType = new SimpleType(rawType, names, parameterTypes);
/*  631 */     return resultType;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public JavaType uncheckedSimpleType(Class<?> cls)
/*      */   {
/*  644 */     return new SimpleType(cls, null, null);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public JavaType constructParametricType(Class<?> parametrized, Class<?>... parameterClasses)
/*      */   {
/*  663 */     int len = parameterClasses.length;
/*  664 */     JavaType[] pt = new JavaType[len];
/*  665 */     for (int i = 0; i < len; i++) {
/*  666 */       pt[i] = _fromClass(parameterClasses[i], null);
/*      */     }
/*  668 */     return constructParametricType(parametrized, pt);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public JavaType constructParametricType(Class<?> parametrized, JavaType... parameterTypes)
/*      */   {
/*      */     JavaType resultType;
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     JavaType resultType;
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  692 */     if (parametrized.isArray())
/*      */     {
/*  694 */       if (parameterTypes.length != 1) {
/*  695 */         throw new IllegalArgumentException("Need exactly 1 parameter type for arrays (" + parametrized.getName() + ")");
/*      */       }
/*  697 */       resultType = constructArrayType(parameterTypes[0]);
/*      */     } else { JavaType resultType;
/*  699 */       if (Map.class.isAssignableFrom(parametrized)) {
/*  700 */         if (parameterTypes.length != 2) {
/*  701 */           throw new IllegalArgumentException("Need exactly 2 parameter types for Map types (" + parametrized.getName() + ")");
/*      */         }
/*  703 */         resultType = constructMapType(parametrized, parameterTypes[0], parameterTypes[1]);
/*      */       } else { JavaType resultType;
/*  705 */         if (Collection.class.isAssignableFrom(parametrized)) {
/*  706 */           if (parameterTypes.length != 1) {
/*  707 */             throw new IllegalArgumentException("Need exactly 1 parameter type for Collection types (" + parametrized.getName() + ")");
/*      */           }
/*  709 */           resultType = constructCollectionType(parametrized, parameterTypes[0]);
/*      */         } else {
/*  711 */           resultType = constructSimpleType(parametrized, parameterTypes);
/*      */         } } }
/*  713 */     return resultType;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   protected JavaType _fromClass(Class<?> clz, TypeBindings context)
/*      */   {
/*  729 */     if (clz.isArray()) {
/*  730 */       return ArrayType.construct(_constructType(clz.getComponentType(), null));
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*  735 */     if (clz.isEnum()) {
/*  736 */       return new SimpleType(clz);
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*  742 */     if (Map.class.isAssignableFrom(clz)) {
/*  743 */       return _mapType(clz);
/*      */     }
/*  745 */     if (Collection.class.isAssignableFrom(clz)) {
/*  746 */       return _collectionType(clz);
/*      */     }
/*  748 */     return new SimpleType(clz);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   protected JavaType _fromParameterizedClass(Class<?> clz, List<JavaType> paramTypes)
/*      */   {
/*  757 */     if (clz.isArray()) {
/*  758 */       return ArrayType.construct(_constructType(clz.getComponentType(), null));
/*      */     }
/*  760 */     if (clz.isEnum()) {
/*  761 */       return new SimpleType(clz);
/*      */     }
/*  763 */     if (Map.class.isAssignableFrom(clz))
/*      */     {
/*      */ 
/*  766 */       if (paramTypes.size() > 0) {
/*  767 */         JavaType keyType = (JavaType)paramTypes.get(0);
/*  768 */         JavaType contentType = paramTypes.size() >= 2 ? (JavaType)paramTypes.get(1) : _unknownType();
/*      */         
/*  770 */         return MapType.construct(clz, keyType, contentType);
/*      */       }
/*  772 */       return _mapType(clz);
/*      */     }
/*  774 */     if (Collection.class.isAssignableFrom(clz)) {
/*  775 */       if (paramTypes.size() >= 1) {
/*  776 */         return CollectionType.construct(clz, (JavaType)paramTypes.get(0));
/*      */       }
/*  778 */       return _collectionType(clz);
/*      */     }
/*  780 */     if (paramTypes.size() == 0) {
/*  781 */       return new SimpleType(clz);
/*      */     }
/*  783 */     JavaType[] pt = (JavaType[])paramTypes.toArray(new JavaType[paramTypes.size()]);
/*  784 */     return constructSimpleType(clz, pt);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   protected JavaType _fromParamType(ParameterizedType type, TypeBindings context)
/*      */   {
/*  802 */     Class<?> rawType = (Class)type.getRawType();
/*  803 */     Type[] args = type.getActualTypeArguments();
/*  804 */     int paramCount = args == null ? 0 : args.length;
/*      */     
/*      */     JavaType[] pt;
/*      */     JavaType[] pt;
/*  808 */     if (paramCount == 0) {
/*  809 */       pt = NO_TYPES;
/*      */     } else {
/*  811 */       pt = new JavaType[paramCount];
/*  812 */       for (int i = 0; i < paramCount; i++) {
/*  813 */         pt[i] = _constructType(args[i], context);
/*      */       }
/*      */     }
/*      */     
/*      */ 
/*  818 */     if (Map.class.isAssignableFrom(rawType)) {
/*  819 */       JavaType subtype = constructSimpleType(rawType, pt);
/*  820 */       JavaType[] mapParams = findTypeParameters(subtype, Map.class);
/*  821 */       if (mapParams.length != 2) {
/*  822 */         throw new IllegalArgumentException("Could not find 2 type parameters for Map class " + rawType.getName() + " (found " + mapParams.length + ")");
/*      */       }
/*  824 */       return MapType.construct(rawType, mapParams[0], mapParams[1]);
/*      */     }
/*  826 */     if (Collection.class.isAssignableFrom(rawType)) {
/*  827 */       JavaType subtype = constructSimpleType(rawType, pt);
/*  828 */       JavaType[] collectionParams = findTypeParameters(subtype, Collection.class);
/*  829 */       if (collectionParams.length != 1) {
/*  830 */         throw new IllegalArgumentException("Could not find 1 type parameter for Collection class " + rawType.getName() + " (found " + collectionParams.length + ")");
/*      */       }
/*  832 */       return CollectionType.construct(rawType, collectionParams[0]);
/*      */     }
/*  834 */     if (paramCount == 0) {
/*  835 */       return new SimpleType(rawType);
/*      */     }
/*  837 */     return constructSimpleType(rawType, pt);
/*      */   }
/*      */   
/*      */ 
/*      */   protected JavaType _fromArrayType(GenericArrayType type, TypeBindings context)
/*      */   {
/*  843 */     JavaType compType = _constructType(type.getGenericComponentType(), context);
/*  844 */     return ArrayType.construct(compType);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   protected JavaType _fromVariable(TypeVariable<?> type, TypeBindings context)
/*      */   {
/*  853 */     if (context == null) {
/*  854 */       return _unknownType();
/*      */     }
/*      */     
/*      */ 
/*  858 */     String name = type.getName();
/*  859 */     JavaType actualType = context.findType(name);
/*  860 */     if (actualType != null) {
/*  861 */       return actualType;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  869 */     Type[] bounds = type.getBounds();
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  884 */     context._addPlaceholder(name);
/*  885 */     return _constructType(bounds[0], context);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   protected JavaType _fromWildcard(WildcardType type, TypeBindings context)
/*      */   {
/*  898 */     return _constructType(type.getUpperBounds()[0], context);
/*      */   }
/*      */   
/*      */   private JavaType _mapType(Class<?> rawClass)
/*      */   {
/*  903 */     JavaType[] typeParams = findTypeParameters(rawClass, Map.class);
/*      */     
/*  905 */     if (typeParams == null) {
/*  906 */       return MapType.construct(rawClass, _unknownType(), _unknownType());
/*      */     }
/*      */     
/*  909 */     if (typeParams.length != 2) {
/*  910 */       throw new IllegalArgumentException("Strange Map type " + rawClass.getName() + ": can not determine type parameters");
/*      */     }
/*  912 */     return MapType.construct(rawClass, typeParams[0], typeParams[1]);
/*      */   }
/*      */   
/*      */   private JavaType _collectionType(Class<?> rawClass)
/*      */   {
/*  917 */     JavaType[] typeParams = findTypeParameters(rawClass, Collection.class);
/*      */     
/*  919 */     if (typeParams == null) {
/*  920 */       return CollectionType.construct(rawClass, _unknownType());
/*      */     }
/*      */     
/*  923 */     if (typeParams.length != 1) {
/*  924 */       throw new IllegalArgumentException("Strange Collection type " + rawClass.getName() + ": can not determine type parameters");
/*      */     }
/*  926 */     return CollectionType.construct(rawClass, typeParams[0]);
/*      */   }
/*      */   
/*      */ 
/*      */   protected JavaType _resolveVariableViaSubTypes(HierarchicType leafType, String variableName, TypeBindings bindings)
/*      */   {
/*  932 */     if ((leafType != null) && (leafType.isGeneric())) {
/*  933 */       TypeVariable<?>[] typeVariables = leafType.getRawClass().getTypeParameters();
/*  934 */       int i = 0; for (int len = typeVariables.length; i < len; i++) {
/*  935 */         TypeVariable<?> tv = typeVariables[i];
/*  936 */         if (variableName.equals(tv.getName()))
/*      */         {
/*  938 */           Type type = leafType.asGeneric().getActualTypeArguments()[i];
/*  939 */           if ((type instanceof TypeVariable)) {
/*  940 */             return _resolveVariableViaSubTypes(leafType.getSubType(), ((TypeVariable)type).getName(), bindings);
/*      */           }
/*      */           
/*  943 */           return _constructType(type, bindings);
/*      */         }
/*      */       }
/*      */     }
/*  947 */     return _unknownType();
/*      */   }
/*      */   
/*      */   protected JavaType _unknownType() {
/*  951 */     return new SimpleType(Object.class, null, null);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   protected static HierarchicType _findSuperTypeChain(Class<?> subtype, Class<?> supertype)
/*      */   {
/*  969 */     if (supertype.isInterface()) {
/*  970 */       return _findSuperInterfaceChain(subtype, supertype);
/*      */     }
/*  972 */     return _findSuperClassChain(subtype, supertype);
/*      */   }
/*      */   
/*      */   protected static HierarchicType _findSuperClassChain(Type currentType, Class<?> target)
/*      */   {
/*  977 */     HierarchicType current = new HierarchicType(currentType);
/*  978 */     Class<?> raw = current.getRawClass();
/*  979 */     if (raw == target) {
/*  980 */       return current;
/*      */     }
/*      */     
/*  983 */     Type parent = raw.getGenericSuperclass();
/*  984 */     if (parent != null) {
/*  985 */       HierarchicType sup = _findSuperClassChain(parent, target);
/*  986 */       if (sup != null) {
/*  987 */         sup.setSubType(current);
/*  988 */         current.setSuperType(sup);
/*  989 */         return current;
/*      */       }
/*      */     }
/*  992 */     return null;
/*      */   }
/*      */   
/*      */   protected static HierarchicType _findSuperInterfaceChain(Type currentType, Class<?> target)
/*      */   {
/*  997 */     HierarchicType current = new HierarchicType(currentType);
/*  998 */     Class<?> raw = current.getRawClass();
/*  999 */     if (raw == target) {
/* 1000 */       return current;
/*      */     }
/*      */     
/* 1003 */     Type[] parents = raw.getGenericInterfaces();
/*      */     
/*      */ 
/* 1006 */     if (parents != null) {
/* 1007 */       for (Type parent : parents) {
/* 1008 */         HierarchicType sup = _findSuperInterfaceChain(parent, target);
/* 1009 */         if (sup != null) {
/* 1010 */           sup.setSubType(current);
/* 1011 */           current.setSuperType(sup);
/* 1012 */           return current;
/*      */         }
/*      */       }
/*      */     }
/*      */     
/* 1017 */     Type parent = raw.getGenericSuperclass();
/* 1018 */     if (parent != null) {
/* 1019 */       HierarchicType sup = _findSuperInterfaceChain(parent, target);
/* 1020 */       if (sup != null) {
/* 1021 */         sup.setSubType(current);
/* 1022 */         current.setSuperType(sup);
/* 1023 */         return current;
/*      */       }
/*      */     }
/* 1026 */     return null;
/*      */   }
/*      */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\type\TypeFactory.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */