/*     */ package org.codehaus.janino.util;
/*     */ 
/*     */ import java.util.ArrayList;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class StringPattern
/*     */ {
/*     */   public static final int INCLUDE = 0;
/*     */   public static final int EXCLUDE = 1;
/*     */   private final int mode;
/*     */   private final String pattern;
/*     */   
/*     */   public StringPattern(int mode, String pattern)
/*     */   {
/*  56 */     this.mode = mode;
/*  57 */     this.pattern = pattern;
/*     */   }
/*     */   
/*     */   public StringPattern(String pattern) {
/*  61 */     this.mode = 0;
/*  62 */     this.pattern = pattern;
/*     */   }
/*     */   
/*  65 */   public int getMode() { return this.mode; }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean matches(String text)
/*     */   {
/*  84 */     return wildmatch(this.pattern, text);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static StringPattern[] parseCombinedPattern(String combinedPattern)
/*     */   {
/*  99 */     ArrayList al = new ArrayList();
/* 100 */     int l; for (int k = 0; k < combinedPattern.length(); k = l)
/*     */     {
/* 102 */       char c = combinedPattern.charAt(k);
/* 103 */       int patternMode; if (c == '+') {
/* 104 */         int patternMode = 0;
/* 105 */         k++;
/*     */       }
/* 107 */       else if (c == '-') {
/* 108 */         int patternMode = 1;
/* 109 */         k++;
/*     */       } else {
/* 111 */         patternMode = 0;
/*     */       }
/* 113 */       for (l = k; l < combinedPattern.length(); l++) {
/* 114 */         c = combinedPattern.charAt(l);
/* 115 */         if ((c == '+') || (c == '-')) break;
/*     */       }
/* 117 */       al.add(new StringPattern(patternMode, combinedPattern.substring(k, l)));
/*     */     }
/* 119 */     return (StringPattern[])al.toArray(new StringPattern[al.size()]);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static boolean matches(StringPattern[] patterns, String text)
/*     */   {
/* 140 */     if (patterns == null) { return false;
/*     */     }
/* 142 */     for (int i = patterns.length - 1; i >= 0; i--) {
/* 143 */       if (patterns[i].matches(text)) {
/* 144 */         return patterns[i].getMode() == 0;
/*     */       }
/*     */     }
/* 147 */     return false; }
/*     */   
/* 149 */   public static final StringPattern[] PATTERNS_ALL = { new StringPattern("*") };
/* 150 */   public static final StringPattern[] PATTERNS_NONE = new StringPattern[0];
/*     */   
/*     */   public String toString() {
/* 153 */     return (this.mode == 1 ? '-' : this.mode == 0 ? '+' : '?') + this.pattern;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private static boolean wildmatch(String pattern, String text)
/*     */   {
/* 162 */     for (int i = 0; i < pattern.length(); i++) {
/* 163 */       char c = pattern.charAt(i);
/* 164 */       switch (c)
/*     */       {
/*     */       case '?': 
/* 167 */         if (i == text.length()) { return false;
/*     */         }
/*     */         break;
/*     */       case '*': 
/* 171 */         if (pattern.length() == i + 1) return true;
/* 172 */         pattern = pattern.substring(i + 1);
/* 173 */         for (; i <= text.length(); i++) {
/* 174 */           if (wildmatch(pattern, text.substring(i))) return true;
/*     */         }
/* 176 */         return false;
/*     */       
/*     */       default: 
/* 179 */         if (i == text.length()) return false;
/* 180 */         if (text.charAt(i) != c) return false;
/*     */         break;
/*     */       }
/*     */     }
/* 184 */     return text.length() == i;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\util\StringPattern.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */