package com.ibm.wsdl.extensions.soap;

import com.ibm.wsdl.Constants;
import com.ibm.wsdl.util.StringUtils;
import com.ibm.wsdl.util.xml.DOMUtils;
import java.io.PrintWriter;
import java.io.Serializable;
import javax.wsdl.Definition;
import javax.wsdl.WSDLException;
import javax.wsdl.extensions.ExtensibilityElement;
import javax.wsdl.extensions.ExtensionDeserializer;
import javax.wsdl.extensions.ExtensionRegistry;
import javax.wsdl.extensions.ExtensionSerializer;
import javax.wsdl.extensions.soap.SOAPFault;
import javax.xml.namespace.QName;
import org.w3c.dom.Element;

public class SOAPFaultSerializer
  implements ExtensionSerializer, ExtensionDeserializer, Serializable
{
  public static final long serialVersionUID = 1L;
  
  public void marshall(Class paramClass, QName paramQName, ExtensibilityElement paramExtensibilityElement, PrintWriter paramPrintWriter, Definition paramDefinition, ExtensionRegistry paramExtensionRegistry)
    throws WSDLException
  {
    SOAPFault localSOAPFault = (SOAPFault)paramExtensibilityElement;
    if (localSOAPFault != null)
    {
      String str = DOMUtils.getQualifiedValue("http://schemas.xmlsoap.org/wsdl/soap/", "fault", paramDefinition);
      paramPrintWriter.print("        <" + str);
      DOMUtils.printAttribute("name", localSOAPFault.getName(), paramPrintWriter);
      DOMUtils.printAttribute("use", localSOAPFault.getUse(), paramPrintWriter);
      DOMUtils.printAttribute("encodingStyle", StringUtils.getNMTokens(localSOAPFault.getEncodingStyles()), paramPrintWriter);
      DOMUtils.printAttribute("namespace", localSOAPFault.getNamespaceURI(), paramPrintWriter);
      Boolean localBoolean = localSOAPFault.getRequired();
      if (localBoolean != null) {
        DOMUtils.printQualifiedAttribute(Constants.Q_ATTR_REQUIRED, localBoolean.toString(), paramDefinition, paramPrintWriter);
      }
      paramPrintWriter.println("/>");
    }
  }
  
  public ExtensibilityElement unmarshall(Class paramClass, QName paramQName, Element paramElement, Definition paramDefinition, ExtensionRegistry paramExtensionRegistry)
    throws WSDLException
  {
    SOAPFault localSOAPFault = (SOAPFault)paramExtensionRegistry.createExtension(paramClass, paramQName);
    QName localQName = DOMUtils.getQualifiedAttributeValue(paramElement, "message", "header", false, paramDefinition);
    String str1 = DOMUtils.getAttribute(paramElement, "name");
    String str2 = DOMUtils.getAttribute(paramElement, "use");
    String str3 = DOMUtils.getAttribute(paramElement, "encodingStyle");
    String str4 = DOMUtils.getAttribute(paramElement, "namespace");
    String str5 = DOMUtils.getAttributeNS(paramElement, "http://schemas.xmlsoap.org/wsdl/", "required");
    if (str1 != null) {
      localSOAPFault.setName(str1);
    }
    if (str2 != null) {
      localSOAPFault.setUse(str2);
    }
    if (str3 != null) {
      localSOAPFault.setEncodingStyles(StringUtils.parseNMTokens(str3));
    }
    if (str4 != null) {
      localSOAPFault.setNamespaceURI(str4);
    }
    if (str5 != null) {
      localSOAPFault.setRequired(new Boolean(str5));
    }
    return localSOAPFault;
  }
}


/* Location:              /Users/anandkum/Downloads/axis-wsdl4j-1.5.1.jar!/com/ibm/wsdl/extensions/soap/SOAPFaultSerializer.class
 * Java compiler version: 2 (46.0)
 * JD-Core Version:       0.7.1
 */