/*    */ package com.sun.xml.bind.v2.runtime;
/*    */ 
/*    */ import java.util.HashSet;
/*    */ import java.util.Set;
/*    */ import org.w3c.dom.Attr;
/*    */ import org.w3c.dom.NamedNodeMap;
/*    */ import org.w3c.dom.Node;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ final class DomPostInitAction
/*    */   implements Runnable
/*    */ {
/*    */   private final Node node;
/*    */   private final XMLSerializer serializer;
/*    */   
/*    */   DomPostInitAction(Node node, XMLSerializer serializer)
/*    */   {
/* 26 */     this.node = node;
/* 27 */     this.serializer = serializer;
/*    */   }
/*    */   
/*    */   public void run()
/*    */   {
/* 32 */     Set<String> declaredPrefixes = new HashSet();
/* 33 */     for (Node n = this.node; (n != null) && (n.getNodeType() == 1); n = n.getParentNode()) {
/* 34 */       NamedNodeMap atts = n.getAttributes();
/* 35 */       if (atts != null) {
/* 36 */         for (int i = 0; i < atts.getLength(); i++) {
/* 37 */           Attr a = (Attr)atts.item(i);
/* 38 */           String nsUri = a.getNamespaceURI();
/* 39 */           if ((nsUri != null) && (nsUri.equals("http://www.w3.org/2000/xmlns/")))
/*    */           {
/* 41 */             String prefix = a.getLocalName();
/* 42 */             if (prefix != null)
/*    */             {
/* 44 */               if (prefix.equals("xmlns")) {
/* 45 */                 prefix = "";
/*    */               }
/* 47 */               String value = a.getValue();
/* 48 */               if (value != null)
/*    */               {
/* 50 */                 if (declaredPrefixes.add(prefix)) {
/* 51 */                   this.serializer.addInscopeBinding(value, prefix);
/*    */                 }
/*    */               }
/*    */             }
/*    */           }
/*    */         }
/*    */       }
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\DomPostInitAction.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */