/*    */ package com.sun.xml.bind.v2.runtime.reflect;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*    */ import java.util.Map;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ final class PrimitiveArrayListerBoolean<BeanT>
/*    */   extends Lister<BeanT, boolean[], Boolean, BooleanArrayPack>
/*    */ {
/*    */   static void register()
/*    */   {
/* 19 */     Lister.primitiveArrayListers.put(Boolean.TYPE, new PrimitiveArrayListerBoolean());
/*    */   }
/*    */   
/*    */   public ListIterator<Boolean> iterator(final boolean[] objects, XMLSerializer context) {
/* 23 */     new ListIterator() {
/* 24 */       int idx = 0;
/*    */       
/* 26 */       public boolean hasNext() { return this.idx < objects.length; }
/*    */       
/*    */       public Boolean next()
/*    */       {
/* 30 */         return Boolean.valueOf(objects[(this.idx++)]);
/*    */       }
/*    */     };
/*    */   }
/*    */   
/*    */   public BooleanArrayPack startPacking(BeanT current, Accessor<BeanT, boolean[]> acc) {
/* 36 */     return new BooleanArrayPack();
/*    */   }
/*    */   
/*    */   public void addToPack(BooleanArrayPack objects, Boolean o) {
/* 40 */     objects.add(o);
/*    */   }
/*    */   
/*    */   public void endPacking(BooleanArrayPack pack, BeanT bean, Accessor<BeanT, boolean[]> acc) throws AccessorException {
/* 44 */     acc.set(bean, pack.build());
/*    */   }
/*    */   
/*    */   public void reset(BeanT o, Accessor<BeanT, boolean[]> acc) throws AccessorException {
/* 48 */     acc.set(o, new boolean[0]);
/*    */   }
/*    */   
/*    */   static final class BooleanArrayPack {
/* 52 */     boolean[] buf = new boolean[16];
/*    */     int size;
/*    */     
/*    */     void add(Boolean b) {
/* 56 */       if (this.buf.length == this.size)
/*    */       {
/* 58 */         boolean[] nb = new boolean[this.buf.length * 2];
/* 59 */         System.arraycopy(this.buf, 0, nb, 0, this.buf.length);
/* 60 */         this.buf = nb;
/*    */       }
/* 62 */       this.buf[(this.size++)] = b.booleanValue();
/*    */     }
/*    */     
/*    */     boolean[] build() {
/* 66 */       if (this.buf.length == this.size)
/*    */       {
/* 68 */         return this.buf;
/*    */       }
/* 70 */       boolean[] r = new boolean[this.size];
/* 71 */       System.arraycopy(this.buf, 0, r, 0, this.size);
/* 72 */       return r;
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\PrimitiveArrayListerBoolean.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */