/*    */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*    */ 
/*    */ import com.sun.xml.bind.DatatypeConverterImpl;
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*    */ import org.xml.sax.Attributes;
/*    */ import org.xml.sax.SAXException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class XsiNilLoader
/*    */   extends ProxyLoader
/*    */ {
/*    */   private final Loader defaultLoader;
/*    */   
/*    */   public XsiNilLoader(Loader defaultLoader)
/*    */   {
/* 21 */     this.defaultLoader = defaultLoader;
/* 22 */     assert (defaultLoader != null);
/*    */   }
/*    */   
/*    */   protected Loader selectLoader(UnmarshallingContext.State state, TagName ea) throws SAXException {
/* 26 */     int idx = ea.atts.getIndex("http://www.w3.org/2001/XMLSchema-instance", "nil");
/*    */     
/* 28 */     if (idx != -1) {
/* 29 */       String value = ea.atts.getValue(idx);
/* 30 */       if (DatatypeConverterImpl._parseBoolean(value)) {
/* 31 */         onNil(state);
/* 32 */         return Discarder.INSTANCE;
/*    */       }
/*    */     }
/*    */     
/* 36 */     return this.defaultLoader;
/*    */   }
/*    */   
/*    */   protected void onNil(UnmarshallingContext.State state)
/*    */     throws SAXException
/*    */   {}
/*    */   
/*    */   public static final class Single
/*    */     extends XsiNilLoader
/*    */   {
/*    */     private final Accessor acc;
/*    */     
/*    */     public Single(Loader l, Accessor acc)
/*    */     {
/* 50 */       super();
/* 51 */       this.acc = acc;
/*    */     }
/*    */     
/*    */     protected void onNil(UnmarshallingContext.State state) throws SAXException {
/*    */       try {
/* 56 */         this.acc.set(state.prev.target, null);
/*    */       } catch (AccessorException e) {
/* 58 */         handleGenericException(e, true);
/*    */       }
/*    */     }
/*    */   }
/*    */   
/*    */   public static final class Array extends XsiNilLoader {
/*    */     public Array(Loader core) {
/* 65 */       super();
/*    */     }
/*    */     
/*    */     protected void onNil(UnmarshallingContext.State state)
/*    */     {
/* 70 */       state.target = null;
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\XsiNilLoader.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */