/*    */ package org.apache.avro.io;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.util.Arrays;
/*    */ import org.apache.avro.AvroTypeException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public abstract class ParsingEncoder
/*    */   extends Encoder
/*    */ {
/* 32 */   private long[] counts = new long[10];
/*    */   
/* 34 */   protected int pos = -1;
/*    */   
/*    */   public void setItemCount(long itemCount) throws IOException
/*    */   {
/* 38 */     if (this.counts[this.pos] != 0L) {
/* 39 */       throw new AvroTypeException("Incorrect number of items written. " + this.counts[this.pos] + " more required.");
/*    */     }
/*    */     
/* 42 */     this.counts[this.pos] = itemCount;
/*    */   }
/*    */   
/*    */   public void startItem() throws IOException
/*    */   {
/* 47 */     this.counts[this.pos] -= 1L;
/*    */   }
/*    */   
/*    */   protected final void push()
/*    */   {
/* 52 */     if (++this.pos == this.counts.length) {
/* 53 */       this.counts = Arrays.copyOf(this.counts, this.pos + 10);
/*    */     }
/* 55 */     this.counts[this.pos] = 0L;
/*    */   }
/*    */   
/*    */   protected final void pop() {
/* 59 */     if (this.counts[this.pos] != 0L) {
/* 60 */       throw new AvroTypeException("Incorrect number of items written. " + this.counts[this.pos] + " more required.");
/*    */     }
/*    */     
/* 63 */     this.pos -= 1;
/*    */   }
/*    */   
/*    */   protected final int depth() {
/* 67 */     return this.pos;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\apache\avro\io\ParsingEncoder.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */