/*    */ package org.apache.avro.util;
/*    */ 
/*    */ import java.io.EOFException;
/*    */ import java.io.IOException;
/*    */ import java.io.InputStream;
/*    */ import java.nio.ByteBuffer;
/*    */ import java.util.List;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ByteBufferInputStream
/*    */   extends InputStream
/*    */ {
/*    */   private List<ByteBuffer> buffers;
/*    */   private int current;
/*    */   
/*    */   public ByteBufferInputStream(List<ByteBuffer> buffers)
/*    */   {
/* 33 */     this.buffers = buffers;
/*    */   }
/*    */   
/*    */ 
/*    */   public int read()
/*    */     throws IOException
/*    */   {
/* 40 */     return getBuffer().get() & 0xFF;
/*    */   }
/*    */   
/*    */ 
/*    */   public int read(byte[] b, int off, int len)
/*    */     throws IOException
/*    */   {
/* 47 */     if (len == 0) return 0;
/* 48 */     ByteBuffer buffer = getBuffer();
/* 49 */     int remaining = buffer.remaining();
/* 50 */     if (len > remaining) {
/* 51 */       buffer.get(b, off, remaining);
/* 52 */       return remaining;
/*    */     }
/* 54 */     buffer.get(b, off, len);
/* 55 */     return len;
/*    */   }
/*    */   
/*    */ 
/*    */   public ByteBuffer readBuffer(int length)
/*    */     throws IOException
/*    */   {
/* 62 */     if (length == 0) return ByteBuffer.allocate(0);
/* 63 */     ByteBuffer buffer = getBuffer();
/* 64 */     if (buffer.remaining() == length) {
/* 65 */       this.current += 1;
/* 66 */       return buffer;
/*    */     }
/*    */     
/* 69 */     ByteBuffer result = ByteBuffer.allocate(length);
/* 70 */     int start = 0;
/* 71 */     while (start < length)
/* 72 */       start += read(result.array(), start, length - start);
/* 73 */     return result;
/*    */   }
/*    */   
/*    */ 
/*    */   private ByteBuffer getBuffer()
/*    */     throws IOException
/*    */   {
/* 80 */     while (this.current < this.buffers.size()) {
/* 81 */       ByteBuffer buffer = (ByteBuffer)this.buffers.get(this.current);
/* 82 */       if (buffer.hasRemaining())
/* 83 */         return buffer;
/* 84 */       this.current += 1;
/*    */     }
/* 86 */     throw new EOFException();
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\apache\avro\util\ByteBufferInputStream.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */