/*    */ package org.hibernate.annotations.common.reflection.java.generics;
/*    */ 
/*    */ import java.lang.reflect.ParameterizedType;
/*    */ import java.lang.reflect.Type;
/*    */ import java.lang.reflect.TypeVariable;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class TypeEnvironmentFactory
/*    */ {
/*    */   public TypeEnvironment getEnvironment(Class context)
/*    */   {
/* 22 */     if (context == null) {
/* 23 */       return IdentityTypeEnvironment.INSTANCE;
/*    */     }
/* 25 */     return createEnvironment(context);
/*    */   }
/*    */   
/*    */   public TypeEnvironment getEnvironment(Type context) {
/* 29 */     if (context == null) {
/* 30 */       return IdentityTypeEnvironment.INSTANCE;
/*    */     }
/* 32 */     return createEnvironment(context);
/*    */   }
/*    */   
/*    */   public TypeEnvironment getEnvironment(Type t, TypeEnvironment context) {
/* 36 */     return CompoundTypeEnvironment.create(getEnvironment(t), context);
/*    */   }
/*    */   
/*    */   public TypeEnvironment toApproximatingEnvironment(TypeEnvironment context) {
/* 40 */     return CompoundTypeEnvironment.create(new ApproximatingTypeEnvironment(), context);
/*    */   }
/*    */   
/*    */   private TypeEnvironment createEnvironment(Type context) {
/* 44 */     (TypeEnvironment)new TypeSwitch()
/*    */     {
/*    */       public TypeEnvironment caseClass(Class classType) {
/* 47 */         return CompoundTypeEnvironment.create(TypeEnvironmentFactory.this.createSuperTypeEnvironment(classType), TypeEnvironmentFactory.this.getEnvironment(classType.getSuperclass()));
/*    */       }
/*    */       
/*    */ 
/*    */ 
/*    */ 
/*    */       public TypeEnvironment caseParameterizedType(ParameterizedType parameterizedType)
/*    */       {
/* 55 */         return TypeEnvironmentFactory.this.createEnvironment(parameterizedType);
/*    */       }
/*    */       
/*    */ 
/*    */ 
/* 60 */       public TypeEnvironment defaultCase(Type t) { throw new IllegalArgumentException("Invalid type for generating environment: " + t); } }.doSwitch(context);
/*    */   }
/*    */   
/*    */ 
/*    */   private TypeEnvironment createSuperTypeEnvironment(Class clazz)
/*    */   {
/* 66 */     Class superclass = clazz.getSuperclass();
/* 67 */     if (superclass == null) {
/* 68 */       return IdentityTypeEnvironment.INSTANCE;
/*    */     }
/*    */     
/* 71 */     Type[] formalArgs = superclass.getTypeParameters();
/* 72 */     Type genericSuperclass = clazz.getGenericSuperclass();
/*    */     
/* 74 */     if ((genericSuperclass instanceof Class)) {
/* 75 */       return IdentityTypeEnvironment.INSTANCE;
/*    */     }
/*    */     
/* 78 */     if ((genericSuperclass instanceof ParameterizedType)) {
/* 79 */       Type[] actualArgs = ((ParameterizedType)genericSuperclass).getActualTypeArguments();
/* 80 */       return new SimpleTypeEnvironment(formalArgs, actualArgs);
/*    */     }
/*    */     
/* 83 */     throw new AssertionError("Should be unreachable");
/*    */   }
/*    */   
/*    */   private TypeEnvironment createEnvironment(ParameterizedType t) {
/* 87 */     Type[] tactuals = t.getActualTypeArguments();
/* 88 */     Type rawType = t.getRawType();
/* 89 */     if ((rawType instanceof Class)) {
/* 90 */       TypeVariable[] tparms = ((Class)rawType).getTypeParameters();
/* 91 */       return new SimpleTypeEnvironment(tparms, tactuals);
/*    */     }
/* 93 */     return IdentityTypeEnvironment.INSTANCE;
/*    */   }
/*    */ }


/* Location:              /Users/anandkum/Downloads/hibernate-commons-annotations-3.0.0.ga.jar!/org/hibernate/annotations/common/reflection/java/generics/TypeEnvironmentFactory.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */