package prefuse.activity;

import java.util.HashMap;
import java.util.Set;

public class ActivityMap
{
  private HashMap m_map = new HashMap();
  private ActivityMap m_parent;
  
  public ActivityMap()
  {
    this(null);
  }
  
  public ActivityMap(ActivityMap paramActivityMap)
  {
    this.m_parent = paramActivityMap;
  }
  
  public void clear()
  {
    this.m_map.clear();
  }
  
  public int size()
  {
    return this.m_map.size();
  }
  
  public Activity get(String paramString)
  {
    Activity localActivity = (Activity)this.m_map.get(paramString);
    return (localActivity == null) && (this.m_parent != null) ? this.m_parent.get(paramString) : localActivity;
  }
  
  public Activity runAt(String paramString, long paramLong)
  {
    Activity localActivity = get(paramString);
    if (localActivity != null) {
      ActivityManager.scheduleAt(localActivity, paramLong);
    }
    return localActivity;
  }
  
  public Activity run(String paramString)
  {
    Activity localActivity = get(paramString);
    if (localActivity != null) {
      ActivityManager.scheduleNow(localActivity);
    }
    return localActivity;
  }
  
  public Activity runAfter(String paramString1, String paramString2)
  {
    Activity localActivity1 = get(paramString1);
    Activity localActivity2 = get(paramString2);
    if ((localActivity1 != null) && (localActivity2 != null)) {
      ActivityManager.scheduleAfter(localActivity1, localActivity2);
    }
    return localActivity2;
  }
  
  public Activity alwaysRunAfter(String paramString1, String paramString2)
  {
    Activity localActivity1 = get(paramString1);
    Activity localActivity2 = get(paramString2);
    if ((localActivity1 != null) && (localActivity2 != null)) {
      ActivityManager.alwaysScheduleAfter(localActivity1, localActivity2);
    }
    return localActivity2;
  }
  
  public Activity cancel(String paramString)
  {
    Activity localActivity = get(paramString);
    if (localActivity != null) {
      localActivity.cancel();
    }
    return localActivity;
  }
  
  public Activity put(String paramString, Activity paramActivity)
  {
    return (Activity)this.m_map.put(paramString, paramActivity);
  }
  
  public void remove(Object paramObject)
  {
    this.m_map.remove(paramObject);
  }
  
  public Object[] keys()
  {
    return this.m_map.keySet().toArray();
  }
  
  public Object[] allKeys()
  {
    Object[] arrayOfObject1 = this.m_map.keySet().toArray();
    if (this.m_parent != null)
    {
      Object[] arrayOfObject2 = this.m_parent.allKeys();
      if ((arrayOfObject2 != null) && (arrayOfObject2.length > 0))
      {
        Object[] arrayOfObject3 = new Object[arrayOfObject1.length + arrayOfObject2.length];
        System.arraycopy(arrayOfObject1, 0, arrayOfObject3, 0, arrayOfObject1.length);
        System.arraycopy(arrayOfObject2, 0, arrayOfObject3, arrayOfObject1.length, arrayOfObject2.length);
        return arrayOfObject3;
      }
    }
    return arrayOfObject1;
  }
  
  public void setParent(ActivityMap paramActivityMap)
  {
    this.m_parent = paramActivityMap;
  }
  
  public ActivityMap getParent()
  {
    return this.m_parent;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\activity\ActivityMap.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */