package prefuse.data.expression;

import java.util.Collections;
import java.util.HashSet;
import java.util.Set;

public class ExpressionAnalyzer
{
  public static boolean hasDependency(Expression paramExpression)
  {
    ColumnCollector localColumnCollector = new ColumnCollector(false);
    paramExpression.visit(localColumnCollector);
    return localColumnCollector.getColumnCount() > 0;
  }
  
  public static Set getReferencedColumns(Expression paramExpression)
  {
    ColumnCollector localColumnCollector = new ColumnCollector(true);
    paramExpression.visit(localColumnCollector);
    return localColumnCollector.getColumnSet();
  }
  
  private static class ColumnCollector
    implements ExpressionVisitor
  {
    private boolean store;
    private Set m_cols;
    private int m_count;
    
    public ColumnCollector(boolean paramBoolean)
    {
      this.store = paramBoolean;
    }
    
    public int getColumnCount()
    {
      return this.m_count;
    }
    
    public Set getColumnSet()
    {
      if (this.m_cols == null) {
        return Collections.EMPTY_SET;
      }
      return this.m_cols;
    }
    
    public void visitExpression(Expression paramExpression)
    {
      if ((paramExpression instanceof ColumnExpression))
      {
        this.m_count += 1;
        if (this.store)
        {
          String str = ((ColumnExpression)paramExpression).getColumnName();
          if (this.m_cols == null) {
            this.m_cols = new HashSet();
          }
          this.m_cols.add(str);
        }
      }
    }
    
    public void down() {}
    
    public void up() {}
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\expression\ExpressionAnalyzer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */