package prefuse.data.expression;

import prefuse.data.Tuple;
import prefuse.util.TypeLib;

public abstract class Literal
  extends AbstractExpression
{
  public static Literal getLiteral(Tuple paramTuple, String paramString)
  {
    Class localClass = paramTuple.getColumnType(paramString);
    if (localClass == Integer.TYPE) {
      return new NumericLiteral(paramTuple.getInt(paramString));
    }
    if (localClass == Long.TYPE) {
      return new NumericLiteral(paramTuple.getLong(paramString));
    }
    if (localClass == Float.TYPE) {
      return new NumericLiteral(paramTuple.getFloat(paramString));
    }
    if (localClass == Double.TYPE) {
      return new NumericLiteral(paramTuple.getDouble(paramString));
    }
    if (localClass == Boolean.TYPE) {
      return new BooleanLiteral(paramTuple.getBoolean(paramString));
    }
    return new ObjectLiteral(paramTuple.get(paramString));
  }
  
  public static Literal getLiteral(Object paramObject)
  {
    return getLiteral(paramObject, paramObject.getClass());
  }
  
  public static Literal getLiteral(Object paramObject, Class paramClass)
  {
    if (TypeLib.isNumericType(paramClass)) {
      return new NumericLiteral(paramObject);
    }
    if (paramClass == Boolean.TYPE) {
      return new BooleanLiteral(((Boolean)paramObject).booleanValue());
    }
    if (paramClass.isInstance(paramObject)) {
      return new ObjectLiteral(paramObject);
    }
    throw new IllegalArgumentException("Object does not match the provided Class type.");
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\expression\Literal.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */