package prefuse.data.tuple;

import java.util.Iterator;
import java.util.LinkedHashSet;
import prefuse.data.Tuple;
import prefuse.data.event.EventConstants;

public class DefaultTupleSet
  extends AbstractTupleSet
  implements EventConstants
{
  protected LinkedHashSet m_tuples = new LinkedHashSet();
  
  public int getTupleCount()
  {
    return this.m_tuples.size();
  }
  
  public Tuple addTuple(Tuple paramTuple)
  {
    paramTuple = addInternal(paramTuple);
    if (paramTuple != null) {
      fireTupleEvent(paramTuple, 1);
    }
    return paramTuple;
  }
  
  public Tuple setTuple(Tuple paramTuple)
  {
    Tuple[] arrayOfTuple1 = clearInternal();
    paramTuple = addInternal(paramTuple);
    Tuple[] arrayOfTuple2 = { paramTuple == null ? null : paramTuple };
    fireTupleEvent(arrayOfTuple2, arrayOfTuple1);
    return paramTuple;
  }
  
  protected final Tuple addInternal(Tuple paramTuple)
  {
    if (this.m_tuples.add(paramTuple)) {
      return paramTuple;
    }
    return null;
  }
  
  public boolean containsTuple(Tuple paramTuple)
  {
    return this.m_tuples.contains(paramTuple);
  }
  
  public boolean removeTuple(Tuple paramTuple)
  {
    boolean bool = removeInternal(paramTuple);
    if (bool) {
      fireTupleEvent(paramTuple, -1);
    }
    return bool;
  }
  
  protected final boolean removeInternal(Tuple paramTuple)
  {
    return this.m_tuples.remove(paramTuple);
  }
  
  public void clear()
  {
    if (getTupleCount() > 0)
    {
      Tuple[] arrayOfTuple = clearInternal();
      fireTupleEvent(null, arrayOfTuple);
    }
  }
  
  public Tuple[] clearInternal()
  {
    Tuple[] arrayOfTuple = new Tuple[getTupleCount()];
    Iterator localIterator = tuples();
    for (int i = 0; localIterator.hasNext(); i++) {
      arrayOfTuple[i] = ((Tuple)localIterator.next());
    }
    this.m_tuples.clear();
    return arrayOfTuple;
  }
  
  public Iterator tuples()
  {
    return this.m_tuples.iterator();
  }
  
  public Tuple[] toArray()
  {
    Tuple[] arrayOfTuple = new Tuple[getTupleCount()];
    this.m_tuples.toArray(arrayOfTuple);
    return arrayOfTuple;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\tuple\DefaultTupleSet.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */