package prefuse.data.util;

import java.util.Iterator;
import java.util.NoSuchElementException;
import prefuse.data.Tuple;
import prefuse.data.expression.Predicate;

public class FilterIterator
  implements Iterator
{
  private Predicate predicate;
  private Iterator tuples;
  private Tuple next;
  
  public FilterIterator(Iterator paramIterator, Predicate paramPredicate)
  {
    this.predicate = paramPredicate;
    this.tuples = paramIterator;
    this.next = advance();
  }
  
  private Tuple advance()
  {
    while (this.tuples.hasNext())
    {
      Tuple localTuple = (Tuple)this.tuples.next();
      if (this.predicate.getBoolean(localTuple)) {
        return localTuple;
      }
    }
    this.tuples = null;
    this.next = null;
    return null;
  }
  
  public Object next()
  {
    if (!hasNext()) {
      throw new NoSuchElementException("No more elements");
    }
    Tuple localTuple = this.next;
    this.next = advance();
    return localTuple;
  }
  
  public boolean hasNext()
  {
    return this.tuples != null;
  }
  
  public void remove()
  {
    throw new UnsupportedOperationException();
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\util\FilterIterator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */